REM---------------------------------------------------------------------------
REM                             Motorama 2001
REM                            von Marty Winkler
REM                         10.03.2001 - 25.06.2001
REM---------------------------------------------------------------------------
REM Variablen :
REM   GLOBAL    MotorStatus
REM                             1 - an
REM                             2 - aus
REM
REM             SchrittWahl
REM                             1 - 1
REM                             2 - 10
REM                             3 - 100
REM                             4 - Selbstdefiniert
REM             SchrittSelbst     - Selbstdefinierte Schrittweite
REM             SchrittWeite      - Schrittweite
REM
REM             PortWahl
REM                             1 - LPT1
REM                             2 - LPT2
REM                             3 - LPT3
REM                             4 - LPT4
REM                             5 - Selbstdefiniert
REM             PortSelbst!       - Selbstdefinierter Port
REM
REM             Knopf( , )        - Feld in dem die deklarierten Knpfe
REM                                 gespeichert sind
REM                         Kopf des Feldes
REM                   0,0         - Anzahl der deklarierten Knpfe
REM                   0,1         - Aktueller Knopf (identisch mit 'Aktuell')
REM                   0,2         - Status des aktuellen Knopfes
REM                                 (0=nicht gedrckt/1=gedrckt)
REM                   0,3         - gedrckter Knopf
REM                         Informationen des Knopfes mit der Nummer n
REM                   n,0         - x-Koordinate der linken oberen Ecke
REM                   n,1         - y-Koordinate der linken oberen Ecke
REM                   n,2         - x-Koordinate der rechten unteren Ecke
REM                   n,3         - y-Koordinate der rechten unteren Ecke
REM                   n,4         - Knopfart
REM                         Knopfarten:
REM                          Nummer  Funktion        Breite   Hhe
REM                             1     "Erhhen"        16      10
REM                             2     "Erniedrigen"    16      10
REM                             3     "Schlieen"      16      14
REM                             4     "Ja"             95      23
REM                             5     "Nein"           95      23
REM             Kreis( , , )      - Feld in dem die deklarierten Kreise
REM                                 gespeichert sind
REM                   0,0,0       - Anzahl der deklarierten Kreisgruppen
REM                   n,0,0       - Anzahl der in dieser Kreisgruppe
REM                                 deklarierten Kreise
REM                   n,0,1       - ausgewhlter Kreis
REM                   n,m,0       - x-Koordinate der linken oberen Ecke
REM                   n,m,1       - y-Koordinate der linken oberen Ecke
REM                   n,m,2       - Modus (0 = Aktiviert / 1 = Deaktiviert)
REM                             (n=Kreisgruppe / m=Kreisnummer)
REM                  
REM             FensterAufbau     - 1 = Fenster wird aufgebaut
REM                               - 0 = Fenster befindet sich nicht (mehr) im
REM                                     Aufbau
REM                               => Befindet sich das Fenster im Aufbau, so
REM                                  wird das Unterprogramm 'Maus' sofort ab-
REM                                  gebrochen. Dadurch werden Grafikfehler
REM                                  vermieden.
REM---------------------------------------------------------------------------
REM
REM $DYNAMIC

   DEFINT A-Z

REM---------------------------------------------------------------------------
REM     globale Variablen deklarieren
REM---------------------------------------------------------------------------
 
   COMMON SHARED xAchse, yAchse
   COMMON SHARED Mausroutine$, MausStatus, MausTaste
   COMMON SHARED MotorStatus, Geschwindigkeit
   COMMON SHARED SchrittWahl, SchrittSelbst, PortWahl, PortSelbst!
   COMMON SHARED FensterX, FensterY, FensterXmax, FensterYmax
   COMMON SHARED FensterNummer, FensterAufbau
   COMMON SHARED Aktuell

REM---------------------------------------------------------------------------
REM     Unterprogramme deklarieren
REM---------------------------------------------------------------------------


   DECLARE SUB Info ()
   DECLARE SUB Ausfuehren ()
   DECLARE SUB BildschirmAufbauen (Nummer)
   DECLARE SUB DeklariereKnopf (xLinks, yOben, Art, Nummer)
   DECLARE SUB DeklariereKreis (xLinks, yOben, Modus, Gruppe, Nummer)
   DECLARE SUB EingabeFenster (xLinks, yOben)
   DECLARE SUB Ende ()
   DECLARE SUB Fehler (Nummer)
   DECLARE SUB Fenster (xLinks, yOben, xRechts, yUnten, Titel$)
   DECLARE SUB Leer ()
   DECLARE SUB Maus (Wahl)
   DECLARE SUB PruefePort (Nummer1, Nummer2&)
   DECLARE SUB PullDownMenu (MenuPunkt)
   DECLARE SUB Schaltskizze ()
   DECLARE SUB Schreibe (Text$, P1, P2, P3, P4, FunktionsNummer)
   DECLARE SUB Systemcheck ()
   DECLARE SUB UeberpruefeKnoepfe ()
   DECLARE SUB UeberpruefeKreise ()
   DECLARE SUB UeberpruefeMenu1 ()
   DECLARE SUB ZeichneKnopf ()
   DECLARE SUB Zeit ()
   DECLARE SUB ZumProgramm ()
   DECLARE SUB ZumProgramm.Ausfuehren ()
   DECLARE SUB ZumProgramm.WeitereProdukte ()
  
REM---------------------------------------------------------------------------
REM     Funktionen deklarieren
REM---------------------------------------------------------------------------

   DECLARE FUNCTION WaehleKreis (Gruppe, Nummer)
   DECLARE FUNCTION UeberpruefeMenu2 (GrenzeTief, GrenzeHoch)

REM---------------------------------------------------------------------------
REM     Datenfelder deklarieren
REM---------------------------------------------------------------------------

   DIM SHARED Knopf(20, 4) AS INTEGER
   DIM SHARED Kreis(3, 5, 2) AS INTEGER
   DIM SHARED Menu(9, 4) AS STRING
   DIM SHARED LPT(5) AS LONG
  
   DIM SHARED Breite(97)
   DIM SHARED Zeichen$(97)

REM---------------------------------------------------------------------------
REM     Fehlerroutine deklarieren
REM---------------------------------------------------------------------------
  
   ON ERROR GOTO Fehlerroutine

REM---------------------------------------------------------------------------
REM             Daten fuer Mausrroutine
REM---------------------------------------------------------------------------

   DATA 55,89,E5,8B,5E,0C,8B,07,50,8B,5E,0A,8B,07,50,8B
   DATA 5E,08,8B,0F,8B,5E,06,8B,17,5B,58,1E,07,CD,33,53
   DATA 8B,5E,0C,89,07,58,8B,5E,0A,89,07,8B,5E,08,89,0F
   DATA 8B,5E,06,89,17,5D,CA,08,00

REM---------------------------------------------------------------------------
REM     Mausroutine erstellen
REM---------------------------------------------------------------------------

   FOR Zaehler = 1 TO 57
     READ Byte$
     Mausroutine$ = Mausroutine$ + CHR$(VAL("&H" + Byte$))
   NEXT

REM---------------------------------------------------------------------------
REM    Ohne Kommentar
REM---------------------------------------------------------------------------

   BildschirmAufbauen 1
   Systemcheck
   BildschirmAufbauen 2
  
REM---------------------------------------------------------------------------
REM     Informationen lesen
REM---------------------------------------------------------------------------
  
   OPEN "system\system.ini" FOR BINARY AS #1
    IF LOF(1) <> 14 THEN
      FensterNummer = 1                 ' Leeres Fenster
      SchrittWahl = 1                   ' Schrittweite => 1
      SchrittSelbst = 50                ' Selbstdefinierte Schrittweite => 50
      PortWahl = 1                      ' Port => LPT1
      PortSelbst! = 0                   ' Selbstdefinierter Port => 0000h
      MotorStatus = 2                   ' Motor => aus
      Geschwindigkeit = 0               ' Motorgeschwindigkeit => 0
    ELSE
      Daten$ = SPACE$(14)
      GET #1, 1, Daten$
      FensterNummer = VAL(LEFT$(Daten$, 1))
      SchrittWahl = VAL(MID$(Daten$, 2, 1))
      SchrittSelbst = VAL(MID$(Daten$, 3, 3))
      PortWahl = VAL(MID$(Daten$, 6, 1))
      PortSelbst! = VAL(MID$(Daten$, 7, 4))
      MotorStatus = VAL(MID$(Daten$, 11, 1))
      Geschwindigkeit = VAL(MID$(Daten$, 12, 3))
    END IF
   CLOSE
  
   REM-------  Informationen berprfen
    IF (FensterNummer < 1) OR (FensterNummer > 5) THEN FensterNummer = 1
    IF (Schritt < 1) OR (Schritt > 3) THEN Schritt = 1
    IF (Port < 1) OR (Port > 5) THEN Port = 1
    IF (MotorStatus < 1) OR (MotorStatus > 2) THEN MotorStatus = 1
    IF (Geschwindigkeit < 0) OR (Geschwindigkeit > 255) THEN Geschwindigkeit = 0
   
REM---------------------------------------------------------------------------
REM     Hauptprogramm
REM---------------------------------------------------------------------------

  DO
    SELECT CASE FensterNummer
      CASE 1: Leer
      CASE 2: Ausfuehren
      CASE 3: Schaltskizze
      CASE 4: ZumProgramm
      CASE 5: Info
    END SELECT
    IF PortWahl <> 0 THEN OUT LPT(PortWahl), 0
    Anfang! = TIMER
    DO: LOOP UNTIL TIMER > Anfang! + .1
   REM-------  Einstellungen rckgngig machen
    Knopf(0, 0) = 1
    Knopf(0, 1) = 0
    Knopf(0, 2) = 0
    Knopf(0, 3) = 0
    FOR Nummer1 = 2 TO 20
      FOR Nummer2 = 0 TO 4
        Knopf(Nummer1, Nummer2) = 0
      NEXT
    NEXT
    FOR Nummer1 = 0 TO 3
      FOR Nummer2 = 0 TO 5
        FOR Nummer3 = 0 TO 2
          Kreis(Nummer1, Nummer2, Nummer3) = 0
        NEXT
      NEXT
    NEXT
    Maus 2
    LINE (1, 41)-(637, 450), 9, BF
  LOOP

REM---------------------------------------------------------------------------
REM     Fehlerroutine
REM---------------------------------------------------------------------------

Fehlerroutine:
 
  Maus 2
  SELECT CASE ERR
    CASE 7:    Nummer = 100
    CASE 14:   Nummer = 100
    CASE 25:   Nummer = 101
    CASE 51:   Nummer = 102
    CASE 57:   Nummer = 103
    CASE 70:   Nummer = 104
    CASE 71:   Nummer = 105
    CASE 75:   Nummer = 106
    CASE 76:   Nummer = 107
    CASE ELSE: Nummer = 0
  END SELECT
  IF (Nummer <> 0) AND Ok = 0 THEN
    Fehler Nummer
    SELECT CASE Nummer
      CASE 1: RESUME 0
      CASE 2: CHAIN "motorama.exe"
      CASE 3: RESUME Ende
    END SELECT
  END IF
  REDIM Hintergrund(9855) AS INTEGER
  GET (112, 140)-(464, 210), Hintergrund(0)
  LINE (112, 140)-(464, 210), 0, BF
  COLOR 2
  LOCATE 10, 15: PRINT "Whrend der Ausfhrung trat ein Fehler auf !"
  LOCATE 11, 15: PRINT "Fehlernummer : "; ERR
  LOCATE 13, 18: PRINT "1) Wiederholen   2) Neustart   3) Ende"
  DO
    SELECT CASE INKEY$
      CASE "1": PUT (112, 140), Hintergrund(0), PSET
                ERASE Hintergrund
                Maus 1
                RESUME 0
      CASE "2": CHAIN "motorama.exe"
      CASE "3": PUT (112, 140), Hintergrund(0), PSET
                RESUME Ende
    END SELECT
  LOOP

REM---------------------------------------------------------------------------
REM     Programm-Ende
REM---------------------------------------------------------------------------

Ende:
 
  END

REM $STATIC
SUB Ausfuehren

REM---------------------------------------------------------------------------
REM     Fenstereigenschaften
REM---------------------------------------------------------------------------
  
   FensterX = 100
   FensterY = 100
   FensterXmax = FensterX + 220
   FensterYmax = FensterY + 170
   FensterAufbau = 1

REM---------------------------------------------------------------------------
REM     Bildschirm aufbauen
REM---------------------------------------------------------------------------

   REM-------  Fenster
    Fenster FensterX, FensterY, FensterXmax, FensterYmax, "Ausfhren"
   
    REM-----------------------------------------------------------------------
    REM         Geschwindigkeit
    
     Schreibe "Geschwindigkeit", FensterX + 20, FensterY + 35, 0, 0, 1
    
     REM-------  Eingabefenster fr "Geschwindigkeit"
      EingabeFenster FensterX + 103, FensterY + 29
      Schreibe LTRIM$(STR$(Geschwindigkeit)), FensterX + 110, FensterY + 35, 0, 0, 1

    REM-----------------------------------------------------------------------
    REM         Schrittweite
    
     Schreibe "Schritt", FensterX + 20, FensterY + 60, 0, 0, 1
     Schreibe "1", FensterX + 40, FensterY + 80, 0, 0, 1
     Schreibe "10", FensterX + 40, FensterY + 95, 0, 0, 1
     Schreibe "100", FensterX + 40, FensterY + 110, 0, 0, 1
     EingabeFenster FensterX + 35, FensterY + 124
     Schreibe LTRIM$(STR$(SchrittSelbst)), FensterX + 42, FensterY + 130, 0, 0, 1
    
     REM-------  Schrittweite berechnen
      IF SchrittWahl = 4 THEN
        SchrittWeite = SchrittSelbst
      ELSE
        SchrittWeite = 10 ^ (SchrittWahl - 1)
      END IF

     REM-------  Kreise fr "Schritt"
      FOR y = 80 TO 110 STEP 15
         DeklariereKreis FensterX + 22, FensterY + y, 0, 1, (y - 80) / 15 + 1
      NEXT
      DeklariereKreis FensterX + 22, FensterY + 130, 0, 1, 4
     
      Kreis(1, 0, 1) = 1
      Unwichtig = WaehleKreis(1, SchrittWahl)
     
    REM-----------------------------------------------------------------------
    REM         Motorstatus
    
     Schreibe "Motor", FensterX + 75, FensterY + 60, 0, 0, 1
     Schreibe "an", FensterX + 95, FensterY + 80, 0, 0, 1
     Schreibe "aus", FensterX + 95, FensterY + 95, 0, 0, 1
    
     REM-------  Kreise fr "Motor"
      FOR y = 80 TO 95 STEP 15
        DeklariereKreis FensterX + 77, FensterY + y, 0, 2, (y - 80) / 15 + 1
      NEXT
      Kreis(2, 0, 1) = 1
      Unwichtig = WaehleKreis(2, MotorStatus)
     
    REM-----------------------------------------------------------------------
    REM         Ausgangsports
    
     Schreibe "Ausgangsport", FensterX + 130, FensterY + 60, 0, 0, 1
  
     REM-------  Portnummern einlesen
      LPT(5) = PortSelbst!

      DEF SEG = 0                               'HighByte*256+LowByte
        FOR Nummer = 2 TO 8 STEP 2
          LPT(Nummer \ 2) = PEEK(&H407 + Nummer) * 256& + PEEK(&H406 + Nummer)
          PruefePort Nummer \ 2, LPT(Nummer \ 2)
        NEXT
      DEF SEG
      DeklariereKreis FensterX + 132, FensterY + 145, 0, 3, 5
     
      EingabeFenster FensterX + 145, FensterY + 139
      Adresse$ = HEX$(PortSelbst!) + "h"
      Adresse$ = STRING$(5 - LEN(Adresse$), "0") + Adresse$
      Schreibe Adresse$, FensterX + 152, FensterY + 145, 0, 0, 1
     
     
      IF PortWahl <> 6 THEN
        Kreis(3, 0, 1) = 1
        Unwichtig = WaehleKreis(3, PortWahl)
        IF LPT(5) = 0 THEN
          DeklariereKreis Kreis(3, 5, 0), Kreis(3, 5, 1), 1, 3, 5
          PortWahl = 0
          DO
            PortWahl = PortWahl + 1
            Vorhanden = WaehleKreis(3, PortWahl)
            IF Vorhanden = 0 THEN EXIT DO
          LOOP UNTIL PortWahl = 4
          IF Vorhanden = 1 THEN PortWahl = 0
        END IF
      ELSE
        PortWahl = 0
      END IF

   FensterAufbau = 0

   IF MotorStatus = 1 THEN
     IF PortWahl <> 0 THEN OUT LPT(PortWahl), Geschwindigkeit
   ELSE
     OUT LPT(PortWahl), 0
   END IF
  
   Maus 1                                    ' Mauszeiger sichtbar

REM---------------------------------------------------------------------------
REM     Und los geht's !
REM---------------------------------------------------------------------------

   DO
     Zeit
     Maus 3
     UeberpruefeKnoepfe
     UeberpruefeKreise
     UeberpruefeMenu1
     IF FensterNummer <> 2 THEN
       IF Aktuell = 1 THEN
         FensterNummer = 2
         Ende
       ELSE
         EXIT DO
       END IF
     END IF
     IF (MausStatus = 1) THEN
       Maus 2
       IF Knopf(0, 3) <> 0 THEN
         SELECT CASE Knopf(0, 3)
           CASE 1: Ende
           CASE 2: FensterNummer = 1: EXIT DO
           CASE 3 TO 4
             LINE (FensterX + 106, FensterY + 31)-STEP(41, 17), 15, BF
             IF Knopf(0, 3) = 3 THEN
               Geschwindigkeit = Geschwindigkeit + SchrittWeite
               IF Geschwindigkeit > 255 THEN Geschwindigkeit = 255
             ELSE
               Geschwindigkeit = Geschwindigkeit - SchrittWeite
               IF Geschwindigkeit < 0 THEN Geschwindigkeit = 0
             END IF
             Schreibe LTRIM$(STR$(Geschwindigkeit)), FensterX + 110, FensterY + 35, 0, 0, 1
             IF MotorStatus = 1 THEN
               IF PortWahl <> 0 THEN OUT LPT(PortWahl), Geschwindigkeit
             ELSE
               OUT LPT(PortWahl), 0
             END IF
           CASE 5 TO 6
             LINE (FensterX + 38, FensterY + 126)-STEP(41, 17), 15, BF
             IF Knopf(0, 3) = 5 THEN
               SchrittSelbst = SchrittSelbst + 1
               IF SchrittSelbst > 255 THEN SchrittSelbst = 255
             ELSE
               SchrittSelbst = SchrittSelbst - 1
               IF SchrittSelbst < 0 THEN SchrittSelbst = 0
             END IF
             IF SchrittWahl = 4 THEN SchrittWeite = SchrittSelbst
             Schreibe LTRIM$(STR$(SchrittSelbst)), FensterX + 42, FensterY + 130, 0, 0, 1
           CASE 7 TO 8
             LINE (FensterX + 148, FensterY + 141)-STEP(41, 17), 15, BF
             IF Knopf(0, 3) = 7 THEN
               PortSelbst! = PortSelbst! + 1
               IF PortSelbst! > 65536 THEN PortSelbst! = 65536
             ELSE
               PortSelbst! = PortSelbst! - 1
               IF PortSelbst! < 0 THEN PortSelbst! = 0
             END IF
             LPT(5) = PortSelbst!
             IF LPT(5) = 0 THEN
               DeklariereKreis Kreis(3, 5, 0), Kreis(3, 5, 1), 1, 3, 5
               IF PortWahl = 5 THEN
                 PortWahl = 0
                 DO
                   PortWahl = PortWahl + 1
                   Vorhanden = WaehleKreis(3, PortWahl)
                   IF Vorhanden = 0 THEN EXIT DO
                 LOOP UNTIL PortWahl = 4
                 IF Vorhanden = 1 THEN PortWahl = 0
               END IF
             ELSEIF Kreis(3, 5, 2) = 1 THEN
               DeklariereKreis Kreis(3, 5, 0), Kreis(3, 5, 1), 0, 3, 5
               IF PortWahl = 0 THEN PortWahl = 5
             END IF
             Adresse$ = HEX$(PortSelbst!) + "h"
             Adresse$ = STRING$(5 - LEN(Adresse$), "0") + Adresse$
             Schreibe Adresse$, FensterX + 152, FensterY + 145, 0, 0, 1
         END SELECT
         Knopf(0, 3) = 0
       ELSE
         SchrittWahl = Kreis(1, 0, 1)
          REM-------  Schrittweite berechnen
           IF SchrittWahl = 4 THEN
             SchrittWeite = SchrittSelbst
           ELSE
             SchrittWeite = 10 ^ (SchrittWahl - 1)
           END IF
         MotorStatus = Kreis(2, 0, 1)
          IF MotorStatus = 1 THEN
            IF PortWahl <> 0 THEN OUT LPT(PortWahl), Geschwindigkeit
          ELSE
            OUT LPT(PortWahl), 0
          END IF
         PortWahl = Kreis(3, 0, 1)
       END IF
     END IF
     Maus 1
   LOOP
  
  REM-------  Motor ausschalten
   IF PortWahl <> 0 THEN OUT LPT(PortWahl), 0

END SUB

SUB BildschirmAufbauen (Nummer)

  SELECT CASE Nummer
    CASE 1
      REM---------------------------------------------------------------------
      REM       Desktop vortuschen
      
       SCREEN 12
       LINE (0, 0)-(639, 451), 9, BF

       REM-------  Start-Zeile
        LINE (0, 452)-(639, 479), 7, BF
        LINE (0, 453)-(639, 453), 15
      
       REM-------  Fenster fr die Zeit
        LINE (637, 456)-(637, 477), 15
        LINE (637, 477)-(599, 477), 15
        LINE (599, 476)-(599, 456), 8
        LINE (599, 456)-(636, 456), 8
      
       REM-------  Programm-Zeile
        LINE (0, 0)-(639, 17), 1, BF
   
    CASE 2
      REM---------------------------------------------------------------------
      REM       Menzeile

       LINE (0, 18)-(639, 37), 7, BF
       Schreibe "Datei", 8, 22, 0, 0, 1
       Schreibe "Hilfe", 45, 22, 0, 0, 1
     
      REM---------------------------------------------------------------------
      REM       Rahmen
 
       REM-------  Oben
        LINE (0, 38)-(639, 38), 15
        LINE (0, 39)-(639, 39), 7
        LINE (0, 40)-(638, 40), 8
      
       REM-------  Rechts
        LINE (639, 40)-(639, 451), 7
        LINE (638, 41)-(638, 450), 15
      
       REM-------  Links
        LINE (0, 41)-(0, 451), 8
      
       REM-------  Unten
        LINE (1, 451)-(638, 451), 15
        LINE (0, 452)-(639, 452), 7
      
       REM-------  Flche
        LINE (1, 41)-(637, 450), 9, BF
 
  END SELECT

END SUB

SUB DeklariereKnopf (xLinks, yOben, Art, Nummer)

  REM-------  Breite und Hhe des Knopfes ermitteln
   SELECT CASE Art
     CASE 1 TO 2: Breite = 16: Hoehe = 10
     CASE 3:      Breite = 16: Hoehe = 14
     CASE 4 TO 5: Breite = 95: Hoehe = 23
   END SELECT
 
  REM-------  Informationen speichern
   IF Nummer = 0 THEN KnopfNummer = Knopf(0, 0) + 1 ELSE KnopfNummer = Nummer
   Knopf(0, 0) = KnopfNummer
 
   Knopf(KnopfNummer, 0) = xLinks
   Knopf(KnopfNummer, 1) = yOben
   Knopf(KnopfNummer, 2) = xLinks + Breite - 1
   Knopf(KnopfNummer, 3) = yOben + Hoehe - 1
   Knopf(KnopfNummer, 4) = Art

  REM-------  Knpfe zeichnen
   Aktuell = KnopfNummer
   ZeichneKnopf
   Aktuell = 0

END SUB

SUB DeklariereKreis (xLinks, yOben, Modus, Gruppe, Nummer)
REM---------------------------------------------------------------------------
REM     Variablen :
REM                     xLinks, yOben - definieren die linke obere Ecke des
REM                                     Kreises
REM                     Modus         - Modus ( 0=Aktiviert / 1=Deaktiviert )
REM                     Gruppe        - Kreisgruppe
REM                     Nummer        - Kreisnummer
REM---------------------------------------------------------------------------
REM             Kreis( , , )
REM                   0,0,0       - Anzahl der deklarierten Kreisgruppen
REM                   n,0,0       - Anzahl der in dieser Kreisgruppe
REM                                 deklarierten Kreise
REM                   n,0,1       - ausgewhlter Kreis
REM                   n,m,0       - x-Koordinate der linken oberen Ecke
REM                   n,m,1       - y-Koordinate der linken oberen Ecke
REM                   n,m,2       - Modus (0 = Aktiviert / 1 = Deaktiviert)
REM---------------------------------------------------------------------------
      
   REM-------  Informationen speichern
    Gruppen = Kreis(0, 0, 0)
    IF Gruppe > Gruppen THEN Kreis(0, 0, 0) = Gruppe
    Kreise = Kreis(Gruppe, 0, 0)
    IF Nummer > Kreise THEN Kreis(Gruppe, 0, 0) = Nummer

    Kreis(Gruppe, Nummer, 0) = xLinks
    Kreis(Gruppe, Nummer, 1) = yOben
    Kreis(Gruppe, Nummer, 2) = Modus

   REM-------  Kreis zeichnen
    IF Modus = 0 THEN Farbe = 15 ELSE Farbe = 7
      
    LINE (xLinks + 2, yOben + 1)-STEP(7, 7), Farbe, BF
    PSET STEP(0, -8), 8
    DRAW "C8 L1 H1 L3 G1 L1 G1 D1 G1 D3 F1 D1"
    DRAW "C15 BF1 R1 F1 R3 E1 R1 E1 U1 E1 U3 H1 U1"
    DRAW "C0 BL1 L1 H1 L3 G1 L1 D1 G1 D3 F1"
    DRAW "C7 BD1 R1 F1 R3 E1 R1 U1 E1 U3 H1"
   
END SUB

SUB EingabeFenster (xLinks, yOben)
  
  REM-------  Weie Flche
   LINE (xLinks + 2, yOben + 2)-STEP(42, 19), 15, BF
 
  REM-------  Rahmen
   DRAW "C15 BM+2,-21 D22 L45 C8 BU1 U21 R44 C7 BD1 D20 L43 C0 BU1 U19 R42"
 
  REM-------  Knpfe deklarieren
   DeklariereKnopf xLinks + 47, yOben + 1, 1, 0
   DeklariereKnopf xLinks + 47, yOben + 11, 2, 0

REM---------------------------------------------------------------------------
REM     EingabeFenster (xLinks, yOben)
REM Variablen :
REM             xLinks, yOben - links obere Ecke des Eingabefensters
REM---------------------------------------------------------------------------

END SUB

SUB Ende
  
   REM-------  Dateien schlieen
    CLOSE

   REM-------  Fensternummer speichern
    FensterNummerSicher = FensterNummer

   REM-------  Motor ausschalten
    IF PortWahl <> 0 THEN OUT LPT(PortWahl), 0
 
   REM-------  Hintergrund abspeichern
    DIM Hintergrund(6440)  AS INTEGER
    Maus 2
     GET (207, 184)-(431, 294), Hintergrund(0)

   FensterAufbau = 1
   REM-------  Fenster aufbauen
    KnopfAnzahl = Knopf(0, 0)
    Fenster 207, 184, 431, 294, "Motorama 2001 beenden"
    Schreibe "Wollen sie Motorama wirklich beenden ?", 230, 222, 0, 0, 1

    DeklariereKnopf 221, 258, 4, 0
    DeklariereKnopf 321, 258, 5, 0
 
   FensterAufbau = 0
   Maus 1

   REM-------  Entscheidung treffen
    DO
      Zeit
      Maus 3
      UeberpruefeKnoepfe
      SELECT CASE Knopf(0, 3)
        CASE KnopfAnzahl + 1: EXIT DO
        CASE KnopfAnzahl + 2
          REM-------  Knopf "Ja" wurde gedrckt
           Knopf(0, 2) = 0
           ZeichneKnopf
         
          REM-------  Kurze Pause
           Anfang! = TIMER
           DO: LOOP UNTIL TIMER > Anfang! + .1
         
          REM-------  Einstellungen speichern
           OPEN "system\system.ini" FOR BINARY AS #1
             Daten$ = SPACE$(14)
             MID$(Daten$, 1, 1) = LTRIM$(STR$(FensterNummer))
             MID$(Daten$, 2, 1) = LTRIM$(STR$(SchrittWahl))
             MID$(Daten$, 3, 3) = LTRIM$(STR$(SchrittSelbst))
             MID$(Daten$, 6, 1) = LTRIM$(STR$(PortWahl))
             MID$(Daten$, 7, 3) = LTRIM$(STR$(PortSelbst!))
             MID$(Daten$, 11, 1) = LTRIM$(STR$(MotorStatus))
             MID$(Daten$, 12, 3) = LTRIM$(STR$(Geschwindigkeit))
             PUT #1, 1, Daten$
           CLOSE
         
          REM-------  Ende
           Maus 2
           CLS
           END
        CASE KnopfAnzahl + 3: EXIT DO
      END SELECT
    LOOP
 
   REM-------  Fensternummer wiederherstellen
    FensterNummer = FensterNummerSicher

   REM-------  Knopf "Nein" wurde gedrckt
    Knopf(0, 2) = 0
    ZeichneKnopf
  
   REM-------  Kurze (Kunst-)Pause
    Anfang! = TIMER
    DO: LOOP UNTIL TIMER > Anfang! + .1
  
   REM-------  Hintergrund wieder herstellen
    Maus 2
      PUT (207, 184), Hintergrund(0), PSET
    Maus 1
    Knopf(0, 0) = KnopfAnzahl
    FOR Nummer = 1 TO 4
      Knopf(0, Nummer) = 0
    NEXT

   REM-------  Motor wieder anschalten, wenn das aktive Fenster "Ausfhren" ist
    IF FensterNummer = 2 THEN
      IF MotorStatus = 1 THEN
        IF PortWahl <> 0 THEN OUT LPT(PortWahl), Geschwindigkeit
      END IF
    END IF

END SUB

SUB Fehler (Nummer)

  CLOSE
 
  Maus 2
  FensterAufbau = 1

  DIM Hintergrund(8509) AS INTEGER                      '210x81
  GET (205, 190)-(415, 271), Hintergrund
 
  Fenster 205, 190, 415, 271, "Fehlermeldung"
 
  BEEP

  SELECT CASE Nummer
    CASE 1                      ' Startknopf + Motoramaknopf [grafik.001]
          Schreibe "Folgende Datei fehlt oder ist fehlerhaft :", 215, 215, 0, 0, 1
          Schreibe "SYSTEM\system.001", 235, 228, 0, 0, 1
          KILL "system\system.001"

    CASE 2                      ' Men                       [grafik.002]
          Schreibe "Folgende Datei fehlt oder ist fehlerhaft :", 215, 215, 0, 0, 1
          Schreibe "SYSTEM\system.002", 235, 228, 0, 0, 1
          KILL "system\system.002"
   
    CASE 100                    ' nicht ausreichend Speicher vorhanden
          Schreibe "Es ist nicht gengend Speicher vorhanden !", 215, 215, 0, 0, 1
   
    CASE 101                    ' es liegt ein Gertefehler vor
          Schreibe "Es liegt ein Gertefehler vor !", 215, 215, 0, 0, 1
   
    CASE 102                    ' es ist ein interner Fehler aufgetreten
          Schreibe "Es ist ein interner Fehler aufgetreten !", 215, 215, 0, 0, 1
   
    CASE 103                    ' Ein-/Ausgabefehler
          Schreibe "Ein-/Ausgabefehler !", 215, 215, 0, 0, 1
   
    CASE 104                    ' Zugriff verweigert auf Datei :
          Schreibe "Der Zugriff auf folgende Datei wurde verweigert :", 215, 215, 0, 0, 1
          Schreibe FehlerDatei$, 235, 228, 0, 0, 1

    CASE 105                    ' Laufwerk  nicht bereit  ERDEV$
          Schreibe "Laufwerk " + ERDEV$ + " ist nicht bereit !", 215, 215, 0, 0, 1
   
    CASE 106                    ' Fehler bei Datei-/Suchwegzugriff
          Schreibe "Fehler bei Datei-/Suchwegzugriff aufgetreten !", 215, 215, 0, 0, 1
   
    CASE 107                    ' Suchweg nicht gefunden
          Schreibe "Suchweg wurde nicht gefunden :", 215, 215, 0, 0, 1
          Schreibe Pfad$, 235, 228, 0, 0, 1

  END SELECT
 
  Schreibe "1) Wiederholen  2) Neustart  3) Ende", 225, 251, 0, 0, 1
  Nummer = 0
 
  FensterAufbau = 0
  Maus 1

  DO
    SELECT CASE INKEY$
      CASE "1": PUT (205, 190), Hintergrund, PSET: EXIT SUB
      CASE "2": RUN "motorama.exe"
      CASE "3": PUT (205, 190), Hintergrund, PSET: END
    END SELECT
  LOOP UNTIL Nummer <> 0
  
END SUB

SUB Fenster (xLinks, yOben, xRechts, yUnten, Titel$)
 
  REM-------  Flche + Titelzeile
   LINE (xLinks, yOben)-(xRechts, yUnten), 7, BF
   LINE (xLinks + 3, yOben + 3)-(xRechts - 3, yOben + 20), 1, BF
   Schreibe Titel$, xLinks + 6, yOben + 7, 15, 0, 1
 
  REM-------  Knopf deklarieren
   Aktuell = 2
   DeklariereKnopf xRechts - 20, yOben + 5, 3, 0
   Aktuell = 0

  REM-------  Rahmen
   LINE (xRechts, yOben)-(xRechts, yUnten), 0
   LINE -(xLinks, yUnten), 0
   LINE (xLinks + 1, yUnten - 1)-(xRechts - 1, yUnten - 1), 8
   LINE -(xRechts - 1, yOben + 1), 8
   LINE -(xLinks + 1, yOben + 1), 15
   LINE -(xLinks + 1, yUnten - 2), 15

END SUB

SUB Info

REM---------------------------------------------------------------------------
REM     Fenstereigenschaften
REM---------------------------------------------------------------------------
 
   FensterX = 162
   FensterY = 158
   FensterXmax = FensterX + 315
   FensterYmax = FensterY + 163
   FensterAufbau = 1

REM---------------------------------------------------------------------------
REM     Bildschirm aufbauen
REM---------------------------------------------------------------------------
   
   REM-------  Fenster
    Fenster FensterX, FensterY, FensterXmax, FensterYmax, "Info"
  
   REM-------  Weie Flche
    LINE (FensterX + 6, FensterY + 25)-(FensterXmax - 6, FensterYmax - 6), 15, BF

   REM-------  Rahmen
    LINE (FensterXmax - 4, FensterY + 25)-(FensterXmax - 4, FensterYmax - 4), 15
    LINE -(FensterX + 6, FensterYmax - 4), 15
    LINE -(FensterX + 6, FensterY + 25), 8
    LINE -(FensterXmax - 5, FensterY + 25), 8
    LINE -(FensterXmax - 5, FensterYmax - 5), 7
    LINE -(FensterX + 7, FensterYmax - 5), 7
    LINE -(FensterX + 7, FensterY + 26), 0
    LINE -(FensterXmax - 6, FensterY + 26), 0
  
   REM-------  Informationen ausgeben
    CONST Farbe = 9
    CONST Schatten = 3
    Schreibe "Motorama 2001", FensterX + 20, FensterY + 30, 0, 9, 3
   
    Schreibe "Programmiert von Marty Winkler", FensterX + 20, FensterY + 57, Farbe, Schatten, 3
    Schreibe "April 2001 bis Juni 2001", FensterX + 40, FensterY + 74, Farbe, Schatten, 3
   
    Schreibe "Es wurde im Rahmen eines Projektes im Informatikunterricht", FensterX + 20, FensterY + 96, Farbe, Schatten, 3
    Schreibe "erstellt. Mit diesem Programm hat man die Mglichkeit, die", FensterX + 20, FensterY + 113, Farbe, Schatten, 3
    Schreibe "Geschwindigkeit eines Motors stufenlos zu steuern.", FensterX + 20, FensterY + 130, Farbe, Schatten, 3
  
   FensterAufbau = 0

   Maus 1
   DO
     Zeit
     Maus 3
     UeberpruefeKnoepfe
     UeberpruefeMenu1
     IF FensterNummer <> 5 THEN
       IF Aktuell = 1 THEN
         FensterNummer = 5
         Ende
       ELSE
         EXIT SUB
       END IF
     END IF
   LOOP

END SUB

SUB Leer

'   FensterAufbau = 1
'     a# = TIMER
'     FOR Wert = 0 TO 150
'       Schreibe "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVW", 10, 100, 1, 0, 3
'     NEXT
'     b# = TIMER
'     PRINT b# - a#, FRE(-1)
'   FensterAufbau = 0
  
   Maus 1
   DO
     Zeit
     Maus 3
     UeberpruefeKnoepfe
     UeberpruefeKreise
     UeberpruefeMenu1
     IF FensterNummer <> 1 THEN
       IF Aktuell = 1 THEN
         FensterNummer = 1
         Ende
       ELSE
         EXIT SUB
       END IF
     END IF
    
     IF Knopf(0, 3) = 1 THEN Ende
   LOOP

END SUB

SUB Maus (Wahl) STATIC

  IF FensterAufbau = 1 THEN EXIT SUB
  IF NOT ((ZeigerAus = 1) AND (Wahl = 2)) THEN
    DEF SEG = VARSEG(Mausroutine$)
      CALL absolute(Wahl, Tasten, xAchse, yAchse, SADD(Mausroutine$))
    DEF SEG
  END IF
  MausTaste = Tasten AND 1
  IF Wahl = 1 THEN ZeigerAus = 0
  IF Wahl = 2 THEN ZeigerAus = 1

REM---------------------------------------------------------------------------
REM     Maus (Wahl) STATIC
REM  Variablen :
REM
REM     MausStatus - Status der linken Maustaste
REM              0 -  linke Maustaste nicht gedrckt         -> auf Dauer
REM              1 -  linke Maustaste nicht mehr gedrckt    -> einmalig
REM              2 -  linke Maustaste das erste Mal gedrckt -> einmalig
REM              3 -  linke Maustaste immer noch gedrckt    -> auf Dauer
REM---------------------------------------------------------------------------

END SUB

SUB PruefePort (Nummer1, Nummer2&)
           
  REM-------  Prft, ob es den angegebenen Port gibt
   Adresse$ = HEX$(Nummer2&) + "h"
   Adresse$ = STRING$(5 - LEN(Adresse$), "0") + Adresse$
   Text$ = "LPT" + LTRIM$(STR$(Nummer1)) + " - " + Adresse$
   IF Nummer2& <> 0 THEN
     Schreibe Text$, FensterX + 150, FensterY + 65 + Nummer1 * 15, 0, 0, 1
     DeklariereKreis FensterX + 132, FensterY + 65 + Nummer1 * 15, 0, 3, Nummer1
     EXIT SUB
   END IF
   Schreibe Text$, FensterX + 151, FensterY + 66 + Nummer1 * 15, 15, 0, 1
   Schreibe Text$, FensterX + 150, FensterY + 65 + Nummer1 * 15, 8, 0, 1
   DeklariereKreis FensterX + 132, FensterY + 65 + Nummer1 * 15, 1, 3, Nummer1
   IF PortWahl = Nummer1 THEN PortWahl = PortWahl + 1

END SUB

SUB PullDownMenu (MenuPunkt)
REM---------------------------------------------------------------------------
REM     PullDownMenu (MenuText(), xLinks, xRechts, TrennZeile)
REM  Variablen:
REM             MenuPunkt       - 1 = Datei / 2 = Hilfe
REM---------------------------------------------------------------------------

   Maus 2
   SELECT CASE MenuPunkt
     CASE 1
       LINE (0, 19)-(36, 36), 1, BF
       Schreibe "Datei", 8, 22, 15, 0, 1
       LINE (37, 19)-(69, 36), 7, BF
       Schreibe "Hilfe", 45, 22, 0, 0, 1
       LINE (0, 37)-(103, 85), 7, BF
       DRAW "C15 BM0,37 R103 G1 L101 D45 G1 NU47 C0 BD1 R104 U48 G1 C8 D46 L102"
       DRAW "BM3,60 R97 D1 C15 L97"
       IF FensterNummer = 2 THEN
         Schreibe "Ausfhren", 26, 43, 8, 15, 3
       ELSE
         Schreibe "Ausfhren", 26, 43, 0, 0, 1
       END IF
       Schreibe "Beenden", 26, 69, 0, 0, 1
     CASE 2
       LINE (0, 19)-(36, 36), 7, BF
       Schreibe "Datei", 8, 22, 0, 0, 1
       LINE (37, 19)-(69, 36), 1, BF
       Schreibe "Hilfe", 45, 22, 15, 0, 1
       LINE (37, 37)-(153, 102), 7, BF
       DRAW "C15 BM37,37 R115 G1 L113 D62 G1 NU64 C0 BD1 R116 U65 G1 C8 D63 L114"
       DRAW "BM40,77 R110 D1 C15 L110"
       IF FensterNummer = 3 THEN
         Schreibe "Schaltskizze", 63, 43, 8, 15, 3
       ELSE
         Schreibe "Schaltskizze", 63, 43, 0, 0, 1
       END IF
       IF FensterNummer = 4 THEN
         Schreibe "Zum Programm", 63, 60, 8, 15, 3
       ELSE
         Schreibe "Zum Programm", 63, 60, 0, 0, 1
       END IF
       IF FensterNummer = 5 THEN
         Schreibe "Info", 63, 86, 8, 15, 3
       ELSE
         Schreibe "Info", 63, 86, 0, 0, 1
       END IF
   END SELECT
   Maus 1

END SUB

SUB Schaltskizze
  
REM---------------------------------------------------------------------------
REM     Fenstereigenschaften
REM---------------------------------------------------------------------------

   FensterX = 172
   FensterY = 74
   FensterXmax = FensterX + 295         'Breite der Schaltskizze: 278
   FensterYmax = FensterY + 330         'Hhe der Schaltzkizze  : 237
   FensterAufbau = 1

REM---------------------------------------------------------------------------
REM     Bildschirm aufbauen
REM---------------------------------------------------------------------------
  
   REM-------  Fenster
    Fenster FensterX, FensterY, FensterXmax, FensterYmax, "Schaltskizze"
 
   REM-------  Weie Flche
    LINE (FensterX + 6, FensterY + 25)-(FensterXmax - 6, FensterYmax - 6), 15, BF

   REM-------  Rahmen
    LINE (FensterXmax - 4, FensterY + 25)-(FensterXmax - 4, FensterYmax - 4), 15
    LINE -(FensterX + 6, FensterYmax - 4), 15
    LINE -(FensterX + 6, FensterY + 25), 8
    LINE -(FensterXmax - 5, FensterY + 25), 8
    LINE -(FensterXmax - 5, FensterYmax - 5), 7
    LINE -(FensterX + 7, FensterYmax - 5), 7
    LINE -(FensterX + 7, FensterY + 26), 0
    LINE -(FensterXmax - 6, FensterY + 26), 0
  
   REM-------  Schaltplan laden
    DIM Schalt.Plan.Teil1(8332) AS INTEGER
    DIM Schalt.Plan.Teil2(8332) AS INTEGER
  
    DEF SEG = VARSEG(Schalt.Plan.Teil1(0))
      BLOAD "system\system.004", VARPTR(Schalt.Plan.Teil1(0))
    DEF SEG
 
    DEF SEG = VARSEG(Schalt.Plan.Teil2(0))
      BLOAD "system\system.005", VARPTR(Schalt.Plan.Teil2(0))
    DEF SEG

   REM-------  Schaltplan anzeigen
    PUT (FensterX + 7, FensterY + 31), Schalt.Plan.Teil1(0), PSET
    PUT (FensterX + 7, FensterY + 149), Schalt.Plan.Teil2(0), PSET

    Schreibe "Entworfen von :", FensterX + 20, FensterY + 272, 0, 1, 1
    Schreibe "Steve Krger", FensterX + 103, FensterY + 272, 0, 1, 1
    Schreibe "Kai Mller", FensterX + 104, FensterY + 289, 0, 1, 1
    Schreibe "Benjamin Bergau", FensterX + 105, FensterY + 306, 0, 1, 1
  
   FensterAufbau = 0
   Maus 1
  
   DO
     Zeit
     Maus 3
     UeberpruefeKnoepfe
     UeberpruefeMenu1
     IF FensterNummer <> 3 THEN
       IF Aktuell = 1 THEN
         FensterNummer = 3
         Ende
       ELSE
         EXIT SUB
       END IF
     END IF
   LOOP

END SUB

REM---------------------------------------------------------------------------
REM     SUB Schreibe (Text$,P1,P2,P3,P4,FunktionsNummer) STATIC
REM
REM     Text$           - beinhaltet den Text
REM     P1              - Parameter Nr. 1
REM     P2              - Parameter Nr. 2
REM     P3              - Parameter Nr. 3
REM     P4              - Parameter Nr. 4
REM     FunktionsNummer - Funktionsnummer
REM                   1 = Text schreiben
REM                         Parameter (P1=x; P2=y; P3=Farbe)
REM                         Rckgabe (P4=Lnge des Textes in Pixeln)
REM                   2 = Lnge des Textes in Pixeln
REM                         Rckgabe (P4=Lnge des Textes in Pixeln)
REM                   3 = Text deaktiviert schreiben
REM                         Parameter (P1=x; P2=y; P3=Farbe; P4=Schattenfarbe)
REM---------------------------------------------------------------------------
SUB Schreibe (Text$, P1, P2, P3, P4, FunktionsNummer) STATIC

   Stelle = 0
   SELECT CASE FunktionsNummer
     CASE 1: P4 = 0
             P1 = P1 - 1
             DO
               Stelle = Stelle + 1
               Zeichen$ = MID$(Text$, Stelle, 1)
               SELECT CASE Zeichen$
                 CASE " " TO "z": Position = ASC(Zeichen$) - 32
                 CASE "": Position = 91
                 CASE "": Position = 92
                 CASE "": Position = 93
                 CASE "": Position = 94
                 CASE "": Position = 95
                 CASE "": Position = 96
                 CASE "": Position = 97
                 CASE ELSE: Position = 0
               END SELECT
   
               PSET (P1, P2), POINT(P1, P2)
               Folge$ = Zeichen$(Position)
               DRAW "C=" + VARPTR$(P3): DRAW "X" + VARPTR$(Folge$)
               P1 = P1 + Breite(Position) + 1
               P4 = P4 + Breite(Position) + 1
               IF P1 > 630 THEN EXIT SUB
             LOOP UNTIL Stelle >= LEN(Text$)
     CASE 2:
             P4 = 0
             DO
               Stelle = Stelle + 1
               Zeichen$ = MID$(Text$, Stelle, 1)
               SELECT CASE Zeichen$
                 CASE " " TO "z": P4 = P4 + Breite(ASC(Zeichen$) - 32)
                 CASE "": P4 = P4 + Breite(91)
                 CASE "": P4 = P4 + Breite(92)
                 CASE "": P4 = P4 + Breite(93)
                 CASE "": P4 = P4 + Breite(94)
                 CASE "": P4 = P4 + Breite(95)
                 CASE "": P4 = P4 + Breite(96)
                 CASE "": P4 = P4 + Breite(97)
                 CASE ELSE
               END SELECT
             LOOP UNTIL Stelle >= LEN(Text$)
     CASE 3: Schreibe Text$, P1 + 1, P2 + 1, P4, 0, 1
             Schreibe Text$, P1, P2, P3, 0, 1
   END SELECT
 

END SUB

SUB Systemcheck

REM---------------------------------------------------------------------------
REM     Schrift initialisieren
REM---------------------------------------------------------------------------

    Breite(0) = 2       ' (Leerzeichen)
     Zeichen$(0) = ""
    Breite(1) = 2       ' !
     Zeichen$(1) = "BR1D6BD2D0"
    Breite(2) = 4       ' "
     Zeichen$(2) = "ND3BR3D3"
    Breite(3) = 6       ' #
     Zeichen$(3) = "BR1ND8BR3ND8BD1R1NL5BD4L5"
    Breite(4) = 5       ' $
     Zeichen$(4) = "BM+4,2H1L2G1D1F2NU5ND4R1F1D1G1L2H1"
    Breite(5) = 7       ' %
     Zeichen$(5) = "BD1F1R1E1H1NL1BR4BD1NG6BD6G1L1H1E1R1"
    Breite(6) = 5       ' &
     Zeichen$(6) = "BD1ND1E1F1D1G1D1G1D2F1R1E1NF1U1NE1H1"
    Breite(7) = 1       ' '
     Zeichen$(7) = "D2"
    Breite(8) = 2       ' (
     Zeichen$(8) = "BR1G1D8F1"
    Breite(9) = 2       ' )
     Zeichen$(9) = "F1D8G1"
    Breite(10) = 3      ' *
     Zeichen$(10) = "BD1F2BL2E2"
    Breite(11) = 5      ' +
     Zeichen$(11) = "BD5R4L2U2D4"
    Breite(12) = 2      ' ,
     Zeichen$(12) = "BD9E1"
    Breite(13) = 2      ' -
     Zeichen$(13) = "BD5R1"
    Breite(14) = 2      ' .
     Zeichen$(14) = "BD8D0"
    Breite(15) = 4      ' /
     Zeichen$(15) = "BD8U1E1U1E1U1E1U2"
    Breite(16) = 5      ' 0
     Zeichen$(16) = "BD1D6F1R2E1U6H1L2"
    Breite(17) = 5      ' 1
     Zeichen$(17) = "BD1R2U1D8"
    Breite(18) = 5      ' 2
     Zeichen$(18) = "BD1E1R2F1D2G4D1R4"
    Breite(19) = 5      '3
     Zeichen$(19) = "BD1E1R2F1D2G1NL1F1D2G1L2H1"
    Breite(20) = 5      '4
     Zeichen$(20) = "BR3ND8G1D1G1D1G1D1R4"
    Breite(21) = 5      '5
     Zeichen$(21) = "NR4D4E1R2F1D3G1L2H1"
    Breite(22) = 5      '6
     Zeichen$(22) = "BD5D2F1R2E1U2H1L3U3E1R2F1"
    Breite(23) = 5      '7
     Zeichen$(23) = "R4D1G1D1G1D1G1D2"
    Breite(24) = 5      '8
     Zeichen$(24) = "BD1D2F1NR2G1D2F1R2E1U2BU2U2H1L2"
    Breite(25) = 5      '9
     Zeichen$(25) = "BR3L2G1D2F1R3U3D6G1L2H1"
    Breite(26) = 2      ':
     Zeichen$(26) = "BD3D0BD5D0"
    Breite(27) = 2      ';
     Zeichen$(27) = "BD9E1BU5U0"
    Breite(28) = 5      '<
     Zeichen$(28) = "BD5NE3F3"
    Breite(29) = 5      '=
     Zeichen$(29) = "BD4R4BD2L4"
    Breite(30) = 5      '>
     Zeichen$(30) = "BD2F3G3"
    Breite(31) = 5      '?
     Zeichen$(31) = "BD1E1R2F1D2G2D1BD2D0"
    Breite(32) = 11     '@
     Zeichen$(32) = "BM+7,9L4H1L1U1H1U3E1U1R1E1R3F1R1D1F1D3L2H1U2L2G1D1F1R1"
    Breite(33) = 7      'A
     Zeichen$(33) = "BD8U1E1NR3U2E1U1E1NU1F1D1F1D2F1D1"
    Breite(34) = 5      'B
     Zeichen$(34) = "R3F1D2G1NL2F1D2G1L3U7"
    Breite(35) = 6      'C
     Zeichen$(35) = "BM+5,1H1L3G1D6F1R3E1"
    Breite(36) = 6      'D
     Zeichen$(36) = "D8R3E2U4H2L2"
    Breite(37) = 6      'E
     Zeichen$(37) = "NR4D4NR3D4R4"
    Breite(38) = 6      'F
     Zeichen$(38) = "NR4D4NR3D4"
    Breite(39) = 6      'G
     Zeichen$(39) = "BM+5,1H1L3G1D6F1R2E1F1U4L2"
    Breite(40) = 7      'H
     Zeichen$(40) = "BR1D8U4R5U4D8"
    Breite(41) = 3      'I
     Zeichen$(41) = "BR1D8"
    Breite(42) = 5      'J
     Zeichen$(42) = "BD6D1F1R1E1U7"
    Breite(43) = 6      'K
     Zeichen$(43) = "D8U5NF5R1E3"
    Breite(44) = 5      'L
     Zeichen$(44) = "D8R4"
    Breite(45) = 7      'M
     Zeichen$(45) = "D8U6R1D1F1D1F1ND1E1U1E1U1R1U2D8"
    Breite(46) = 7      'N
     Zeichen$(46) = "BR1ND8F1D1F1D1F2D1F1U8"
    Breite(47) = 7      'O
     Zeichen$(47) = "BR1BD1D6F1R3E1U6H1L3"
    Breite(48) = 7      'P
     Zeichen$(48) = "BR1ND8R4F1D2G1L3"
    Breite(49) = 6      'Q
     Zeichen$(49) = "BD1D6F1R3NF1U1NH1R1U6H1L3"
    Breite(50) = 7      'R
     Zeichen$(50) = "BR1ND8R4F1D2G1NL3F1D3"
    Breite(51) = 6      'S
     Zeichen$(51) = "BM+5,1H1L2G1D2F1R2F1D2G1L2H1"
    Breite(52) = 6      'T
     Zeichen$(52) = "BR1R4L2D8"
    Breite(53) = 7      'U
     Zeichen$(53) = "BR1D7F1R3E1U7"
    Breite(54) = 7      'V
     Zeichen$(54) = "D1F1D2F1D1F1ND1E1U1E1U2E1U1"
    Breite(55) = 11     'W
     Zeichen$(55) = "D1F1D2F1D1F1ND1E1U1E1NU2F1D1F1ND1E1U1E1U2E1U1"
    Breite(56) = 7      'X
     Zeichen$(56) = "D1F6D1BL6U1E6U1"
    Breite(57) = 6      'Y
     Zeichen$(57) = "D1F3ND4E3U1"
    Breite(58) = 7      'Z
     Zeichen$(58) = "R6D1G6D1R6"
    Breite(59) = 2      '[
     Zeichen$(59) = "NR1D10R1"
    Breite(60) = 4      '\
     Zeichen$(60) = "D2F1D1F1D1F1D1"
    Breite(61) = 2      ']
     Zeichen$(61) = "R1D10L1"
    Breite(62) = 5       '^
     Zeichen$(62) = "BD1E2F2"
    Breite(63) = 6      '_
     Zeichen$(63) = "BD10L1R5"
    Breite(64) = 2      '`
     Zeichen$(64) = "F1"
    Breite(65) = 5      'a
     Zeichen$(65) = "BD6D1F1R3U3NL3U1H1L2"
    Breite(66) = 5      'b
     Zeichen$(66) = "D8R3E1U3H1L2"
    Breite(67) = 5      'c
     Zeichen$(67) = "BM+4,4H1L2G1D3F1R2E1"
    Breite(68) = 5      'd
     Zeichen$(68) = "BR4D8L3H1U3E1R2"
    Breite(69) = 5      'e
     Zeichen$(69) = "BD4E1R2F1D1L4D2F1R2E1"
    Breite(70) = 2      'f
     Zeichen$(70) = "BR1G1D2NR1D5"
    Breite(71) = 5      'g
     Zeichen$(71) = "BD10R3E1U6L3G1D3F1R2"
    Breite(72) = 5      'h
     Zeichen$(72) = "D8U4R1E1R1F1D4"
    Breite(73) = 1      'i
     Zeichen$(73) = "D0BD3D5"
    Breite(74) = 1      'j
     Zeichen$(74) = "D0BD3D7"
    Breite(75) = 5      'k
     Zeichen$(75) = "D8U3R1NE2F3"
    Breite(76) = 1      'l
     Zeichen$(76) = "D8"
    Breite(77) = 7      'm
     Zeichen$(77) = "BD8U5R2F1ND4E1R1F1D4"
    Breite(78) = 5      'n
     Zeichen$(78) = "BD8U5F1E1R1F1D4"
    Breite(79) = 5      'o
     Zeichen$(79) = "BD7U3E1R2F1D3G1L2"
    Breite(80) = 5      'p
     Zeichen$(80) = "BD10U7R3F1D3G1L2"
    Breite(81) = 5      'q
     Zeichen$(81) = "BM+4,10U7L3G1D3F1R2"
    Breite(82) = 2      'r
     Zeichen$(82) = "BD8U5R1"
    Breite(83) = 4      's
     Zeichen$(83) = "BD7F1R1E1H3E1R1F1"
    Breite(84) = 2      't
     Zeichen$(84) = "BD1D2NR1D4F1"
    Breite(85) = 5      'u
     Zeichen$(85) = "BD3D4F1R1E1F1U5"
    Breite(86) = 5       'v
     Zeichen$(86) = "BD3D1F1D1F1ND1E1U1E1U1"
    Breite(87) = 7      'w
     Zeichen$(87) = "BD3D3F1ND1E1U1E1NU1F1D1F1ND1E1U3"
    Breite(88) = 4      'x
     Zeichen$(88) = "BD2D2F1D1G1D1BR3U1H1U1E1U1"
    Breite(89) = 4      'y
     Zeichen$(89) = "BD3ND3BR3D3G1L1D2G1L1"
    Breite(90) = 4      'z
     Zeichen$(90) = "BD3R3D1G3D1R3"
    Breite(91) = 5      '
     Zeichen$(91) = "BD8U7E1R1F1D3NL1F1D2G1L1"
    Breite(92) = 7      '
     Zeichen$(92) = "BU2BR1R0BR4R0BG2D1G1D1G1D2G1D1BR6U1H1NL3U2H1U1"
    Breite(93) = 6      '
     Zeichen$(93) = "BD1D6F1R3E1U6H1L3BU2R0BR3R0"
    Breite(94) = 6      '
     Zeichen$(94) = "D7F1R3E1U7BH1BU1L0BL3L0"
    Breite(95) = 5      '
     Zeichen$(95) = "BR4L0BL3D0BD3R2F1D4L3H1U1E1R2"
    Breite(96) = 5      '
     Zeichen$(96) = "L0BR4D0BD4D3G1L2H1U3E1R2"
    Breite(97) = 5      '
     Zeichen$(97) = "L0BR4D0BD3D5H1G1L1H1U4"

REM---------------------------------------------------------------------------
REM    Grafiken fr Desktop checken
REM---------------------------------------------------------------------------

   REM------------------------------------------------------------------------
   REM     Startknopf [Anzeigen]
   REM------------------------------------------------------------------------
   
    DO
      OPEN "system\system.001" FOR BINARY AS #1
      IF LOF(1) = 0 THEN Fehler 1 ELSE EXIT DO
    LOOP
    CLOSE
    DIM StartKnopf(597) AS INTEGER
    DEF SEG = VARSEG(StartKnopf(0))
      BLOAD "system\system.001", VARPTR(StartKnopf(0))
    DEF SEG
    PUT (2, 456), StartKnopf(0), PSET
  
   REM------------------------------------------------------------------------
   REM     Motorama-Programmknopf [Anzeigen]
   REM------------------------------------------------------------------------
   
    DO
      OPEN "system\system.002" FOR BINARY AS #1
      IF LOF(1) = 0 THEN Fehler 2 ELSE EXIT DO
    LOOP
    CLOSE
    DIM ProgrammKnopf(1059) AS INTEGER
    DEF SEG = VARSEG(ProgrammKnopf(0))
      BLOAD "system\system.002", VARPTR(ProgrammKnopf(0))
    DEF SEG
    PUT (59, 456), ProgrammKnopf(0), PSET
  
   REM------------------------------------------------------------------------
   REM     Programmtitel [Anzeigen]
   REM------------------------------------------------------------------------

    DO
      OPEN "system\system.003" FOR BINARY AS #1
      IF LOF(1) = 0 THEN Fehler 3 ELSE EXIT DO
    LOOP
    CLOSE
    DIM Titel(957) AS INTEGER
    DEF SEG = VARSEG(Titel(0))
      BLOAD "system\system.003", VARPTR(Titel(0))
    DEF SEG
    PUT (0, 0), Titel(0), PSET
  
   REM------------------------------------------------------------------------
   REM     Knpfe: "Minimieren", "Maximieren", "Schlieen" [Anzeigen]
   REM------------------------------------------------------------------------

    PSET (588, 2), 15
    DRAW "C15 ND12 R0 R15 C0 D13 L15 C8 BE1 R13 U11 C7 BL1 L12 D10 R12 U9 BL1 P7,7"
    DRAW "BM-3,7 C8 L5 D1 R5 C15 BR1 D1 L5"
    PSET (604, 2), 15
    DRAW "C15 ND12 R0 R15 C0 D13 L15 C8 BE1 R13 U11 C7 BL1 L12 D10 R12 U9 BL1 P7,7"
    DRAW "BL2 C8 L5 D1 ND1 R5 D4 L2 D3 L5 U4 R5 U1 L5 C15 BM+1,2 NR3 D2 BD2 R5 U3 R2 U5 BM-2,1 L3"
                                                      
    DeklariereKnopf 622, 2, 3, 1

END SUB

SUB UeberpruefeKnoepfe
 
  IF MausTaste = 0 THEN
    IF MausStatus > 1 THEN
      MausStatus = 1
      IF (xAchse >= Knopf(Aktuell, 0)) AND (xAchse <= Knopf(Aktuell, 2)) THEN
        IF (yAchse >= Knopf(Aktuell, 1)) AND (yAchse <= Knopf(Aktuell, 3)) THEN
          Knopf(0, 2) = 0
          ZeichneKnopf
          Knopf(0, 3) = Aktuell
          IF Knopf(Aktuell, 4) = 3 THEN FensterNummer = 1
          EXIT SUB
        END IF
      END IF
      EXIT SUB
    ELSE
      MausStatus = 0
      Aktuell = 0
      EXIT SUB
    END IF
  ELSE
    IF MausStatus > 1 THEN
      MausStatus = 3
      IF (xAchse >= Knopf(Aktuell, 0)) AND (xAchse <= Knopf(Aktuell, 2)) THEN
        IF (yAchse >= Knopf(Aktuell, 1)) AND (yAchse <= Knopf(Aktuell, 3)) THEN
          IF Knopf(0, 2) = 0 THEN
            Knopf(0, 2) = 1
            ZeichneKnopf
          END IF
          EXIT SUB
        END IF
      END IF
      IF Knopf(0, 2) = 1 THEN Knopf(0, 2) = 0: ZeichneKnopf
      EXIT SUB
    ELSE
      MausStatus = 2
      FOR Nummer = 1 TO Knopf(0, 0)
        IF (xAchse >= Knopf(Nummer, 0)) AND (xAchse <= Knopf(Nummer, 2)) THEN
          IF (yAchse >= Knopf(Nummer, 1)) AND (yAchse <= Knopf(Nummer, 3)) THEN
            Aktuell = Nummer
            Knopf(0, 2) = 0
            ZeichneKnopf
            EXIT SUB
          END IF
        END IF
      NEXT
    END IF
  END IF

END SUB

SUB UeberpruefeKreise

   IF MausStatus <> 2 THEN EXIT SUB
  
   FOR Gruppe = 1 TO Kreis(0, 0, 0)
     FOR Nummer = 1 TO Kreis(Gruppe, 0, 0)
       IF Kreis(Gruppe, Nummer, 2) = 0 THEN
         Grenze = Kreis(Gruppe, Nummer, 0)
         IF (xAchse >= Grenze + 1) AND (xAchse <= Grenze + 8) THEN
           Grenze = Kreis(Gruppe, Nummer, 1)
           IF (yAchse >= Grenze + 1) AND (yAchse <= Grenze + 8) THEN
             Unwichtig = WaehleKreis(Gruppe, Nummer)
            END IF
         END IF
       END IF
     NEXT
   NEXT
     
END SUB

SUB UeberpruefeMenu1

  REM-------  Abbruchbedingungen
   IF MausStatus <> 2 THEN EXIT SUB
   IF (yAchse < 19) OR (yAchse > 36) THEN EXIT SUB
   IF (xAchse > 69) THEN EXIT SUB

  REM-------  Motor ausschalten, wenn aktives Fenster "Ausfhren" ist
   IF FensterNummer = 2 THEN IF PortWahl <> 0 THEN OUT LPT(PortWahl), 0

  REM-------  Was wurde angeklickt ?
   IF xAchse < 37 THEN MenuPunkt = 1 ELSE MenuPunkt = 2
  
  REM-------  Mauszeiger ausschalten, Pull-Down Men zeichnen
   Maus 2
   REDIM Hintergrund(5284) AS INTEGER
   GET (0, 37)-(153, 102), Hintergrund(0)
   PullDownMenu MenuPunkt
   Maus 1
  
  REM-------  Men
   DO
     Zeit
     Maus 3
     UeberpruefeKnoepfe
     UeberpruefeKreise
     SELECT CASE MausStatus
       CASE 1
         IF (Wahl = WahlAlt) AND (MenuPunkt = MenuPunktAlt) THEN
           IF Wahl <> 0 THEN
             IF FensterNummer <> FensterWahl THEN Fertig = 1: EXIT DO
           END IF
         END IF
       CASE 2
         IF yAchse < 36 THEN EXIT DO
         SELECT CASE MenuPunkt
           CASE 1: IF (xAchse > 116) OR (yAchse > 85) THEN EXIT DO
           CASE 2: IF (xAchse > 153) OR (yAchse > 102) THEN EXIT DO
         END SELECT
     END SELECT
     MenuPunktAlt = MenuPunkt
     WahlAlt = Wahl
     Wahl = 0
     IF (yAchse > 18) AND (yAchse < 37) THEN
       IF xAchse < 37 THEN MenuPunkt = 1
       IF (xAchse > 36) AND (xAchse < 70) THEN MenuPunkt = 2
     END IF
     IF MenuPunkt <> MenuPunktAlt THEN
       Maus 2
       PUT (0, 37), Hintergrund(0), PSET
       PullDownMenu MenuPunkt
     END IF
     SELECT CASE MenuPunkt
       CASE 1
         IF (xAchse > 2) AND (xAchse < 101) THEN
           IF (yAchse > 39) AND (yAchse < 57) THEN Wahl = 1: FensterWahl = 2
           IF (yAchse > 65) AND (yAchse < 83) THEN Wahl = 2: FensterWahl = -1
         END IF
       CASE 2
         IF (xAchse > 39) AND (xAchse < 151) THEN
           IF (yAchse > 39) AND (yAchse < 57) THEN Wahl = 1: FensterWahl = 3
           IF (yAchse > 56) AND (yAchse < 74) THEN Wahl = 2: FensterWahl = 4
           IF (yAchse > 82) AND (yAchse < 100) THEN Wahl = 3: FensterWahl = 5
         END IF
     END SELECT
     IF (Wahl <> WahlAlt) OR (MenuPunkt <> MenuPunktAlt) THEN
       Maus 2
       SELECT CASE MenuPunktAlt
         CASE 1
           SELECT CASE WahlAlt
             CASE 1: LINE (3, 40)-(100, 56), 7, BF
                     IF FensterNummer = 2 THEN
                       Schreibe "Ausfhren", 26, 43, 8, 15, 3
                     ELSE
                       Schreibe "Ausfhren", 26, 43, 0, 0, 1
                     END IF
             CASE 2: LINE (3, 66)-(100, 82), 7, BF
                     Schreibe "Beenden", 26, 69, 0, 0, 1
           END SELECT
         CASE 2
           SELECT CASE WahlAlt
             CASE 1: LINE (40, 40)-(150, 56), 7, BF
                     IF FensterNummer = 3 THEN
                       Schreibe "Schaltskizze", 63, 43, 8, 15, 3
                     ELSE
                       Schreibe "Schaltskizze", 63, 43, 0, 0, 1
                     END IF
             CASE 2: LINE (40, 57)-(150, 73), 7, BF
                     IF FensterNummer = 4 THEN
                       Schreibe "Zum Programm", 63, 60, 8, 15, 3
                     ELSE
                       Schreibe "Zum Programm", 63, 60, 0, 0, 1
                     END IF
             CASE 3: LINE (40, 83)-(150, 99), 7, BF
                     IF FensterNummer = 5 THEN
                       Schreibe "Info", 63, 86, 8, 15, 3
                     ELSE
                       Schreibe "Info", 63, 86, 0, 0, 1
                     END IF
           END SELECT
       END SELECT
'PullDownMenu MenuPunkt
       SELECT CASE MenuPunkt
         CASE 1
           SELECT CASE Wahl
             CASE 1: LINE (3, 40)-(100, 56), 1, BF
                     IF FensterNummer = 2 THEN Farbe = 8 ELSE Farbe = 15
                     Schreibe "Ausfhren", 26, 43, Farbe, 0, 1
             CASE 2: LINE (3, 66)-(100, 82), 1, BF
                     Schreibe "Beenden", 26, 69, 15, 0, 1
                     END SELECT
         CASE 2
           SELECT CASE Wahl
             CASE 1: LINE (40, 40)-(150, 56), 1, BF
                     IF FensterNummer = 3 THEN Farbe = 8 ELSE Farbe = 15
                     Schreibe "Schaltskizze", 63, 43, Farbe, 0, 1
             CASE 2: LINE (40, 57)-(150, 73), 1, BF
                     IF FensterNummer = 4 THEN Farbe = 8 ELSE Farbe = 15
                     Schreibe "Zum Programm", 63, 60, Farbe, 0, 1
             CASE 3: LINE (40, 83)-(150, 99), 1, BF
                     IF FensterNummer = 5 THEN Farbe = 8 ELSE Farbe = 15
                     Schreibe "Info", 63, 86, Farbe, 0, 1
           END SELECT
       END SELECT
       Maus 1
     END IF
   LOOP
  
  REM-------  Hintergrund wieder herstellen
   Maus 2
     LINE (0, 19)-(69, 36), 7, BF
     Schreibe "Datei", 8, 22, 0, 0, 1
     Schreibe "Hilfe", 45, 22, 0, 0, 1
     PUT (0, 37), Hintergrund(0), PSET
   Maus 1
 
  REM-------  Auswahl auswerten
   IF (Fertig = 1) AND (FensterWahl = -1) THEN
     Ende
   ELSE
     IF Fertig = 1 THEN FensterNummer = FensterWahl
   END IF

END SUB

REM---------------------------------------------------------------------------
REM     FUNCTION UeberpruefeMenu2 (GrenzeTief, GrenzeHoch) STATIC
REM
REM     GrenzeTief, GrenzeHoch - die Knpfe, die zwischen diesen beiden Werten
REM                              liegen werden berprft
REM
REM---------------------------------------------------------------------------
REM
REM     Wahl1 - wenn <> 0, dann ist ein Menpunkt farblich gekennzeichnet
REM     Wahl2 - wenn <> 0, dann wurde aktueller Menpunkt angeklickt
REM     WahlX - Kontrollvariable der x-Achse
REM     WahlY - Kontrollvariable der y-Achse
REM
REM     aktueller Menpunkt heit:
REM             wenn die Variable Wert den Wert 4 enthlt, ist der
REM             Menpunkt Nr. 4 der aktuelle Menpunkt
REM---------------------------------------------------------------------------
FUNCTION UeberpruefeMenu2 (GrenzeTief, GrenzeHoch) STATIC

  IF MausStatus = 0 THEN Wahl2 = 0
 
  FOR Wert = GrenzeTief TO GrenzeHoch
    WahlX = 0: WahlY = 0: Wahl = 0
  
   REM-------  Koordinaten berprfen
    IF xAchse > VAL(Menu(Wert, 1)) - 2 THEN WahlX = 1
    IF xAchse < VAL(Menu(Wert, 1)) + VAL(Menu(Wert, 3)) + 2 THEN WahlX = WahlX + 1
    IF yAchse > VAL(Menu(Wert, 2)) - 2 THEN WahlY = 1
    IF yAchse < VAL(Menu(Wert, 2)) + 12 THEN WahlY = WahlY + 1
   
    IF (WahlX = 2) AND (WahlY = 2) THEN
    
     REM-------  Maus befindet sich ber dem aktuellen Menpunkt:
      IF Wahl1 = Wert THEN
       
       ' aktueller Menpunkt ist bereits farblich gekennzeichnet:
       ' wenn Maustaste gedrckt wird, aktuellen Menpunkt merken
       ' wenn Maustaste nicht mehr gedrckt wird (einmalig),
       ' gemerkten Menpunkt zurckgeben
        IF MausStatus > 1 THEN Wahl2 = Wert
        IF (MausStatus = 1) AND (Wahl2 = Wert) THEN UeberpruefeMenu2 = Wert
        EXIT FUNCTION
      ELSE
      
       ' aktueller Menpunkt ist noch nicht farblich gekennzeichnet:
       ' wenn Maustaste nicht gedrckt wird, oder aktueller
       ' Menpunkt gemerkt wurde, dann Menpunkt farblich kennzeichnen
        IF (MausStatus < 3) OR (Wahl2 = Wert) THEN
          Wahl1 = Wert
          Maus 2
            FOR Wert1 = GrenzeTief TO GrenzeHoch
              Schreibe Menu(Wert1, 0), VAL(Menu(Wert1, 1)), VAL(Menu(Wert1, 2)), 9, 0, 1
            NEXT
            Schreibe Menu(Wert, 0), VAL(Menu(Wert, 1)), VAL(Menu(Wert, 2)), 1, 0, 1
          Maus 1
        END IF
      END IF
      EXIT FUNCTION
    ELSEIF Wahl1 = Wert THEN
     
     ' aktueller Menpunkt ist bereits farblich gekennzeichnet, aber Maus
     ' befindet sich nicht ber diesem Menpunkt:
     ' farbliche Kennzeichnung aufheben
      Wahl1 = 0
      Maus 2
        Schreibe Menu(Wert, 0), VAL(Menu(Wert, 1)), VAL(Menu(Wert, 2)), 9, 0, 1
      Maus 1
    END IF
  NEXT

END FUNCTION

FUNCTION WaehleKreis (Gruppe, Nummer)
  
  
  REM-------  Parameter auf Korrektheit berprfen
   IF Gruppe <= Kreis(0, 0, 0) THEN
     IF Nummer <= Kreis(Gruppe, 0, 0) THEN
       IF Kreis(Gruppe, Nummer, 2) = 0 THEN
   
         REM-------  Koordinaten des zuletzt gewhlten Kreises ermitteln
          xLinksAlt = Kreis(Gruppe, Kreis(Gruppe, 0, 1), 0)
          yObenAlt = Kreis(Gruppe, Kreis(Gruppe, 0, 1), 1)
          IF Kreis(Gruppe, Kreis(Gruppe, 0, 1), 2) = 1 THEN Farbe = 7 ELSE Farbe = 15

         REM-------  Koordinaten des neu gewhlten Kreises ermitteln
          xLinks = Kreis(Gruppe, Nummer, 0)
          yOben = Kreis(Gruppe, Nummer, 1)
                            
          Kreis(Gruppe, 0, 1) = Nummer

         Maus 2
        
         REM-------  Punkt lschen
          LINE (xLinksAlt + 4, yObenAlt + 4)-STEP(3, 1), Farbe, BF
          LINE (xLinksAlt + 5, yObenAlt + 3)-STEP(1, 3), Farbe, BF
 
         REM-------  Punkt setzten
          LINE (xLinks + 4, yOben + 4)-STEP(3, 1), 0, BF
          LINE (xLinks + 5, yOben + 3)-STEP(1, 3), 0, BF
        
         Maus 1

         EXIT FUNCTION
       END IF
     END IF
   END IF

   WaehleKreis = 1

END FUNCTION

SUB ZeichneKnopf

  Maus 2

  LINE (Knopf(Aktuell, 2), Knopf(Aktuell, 3))-(Knopf(Aktuell, 0), Knopf(Aktuell, 1)), 7, BF
 
  IF Knopf(0, 2) = 0 THEN
    SELECT CASE Knopf(Aktuell, 4)
      CASE 1: DRAW "C0 BM+0,9 R15 U9 C8 BG1 D7 L13 C15 BU1 U6 R12 BM-6,3 C0 G1 R2"
      CASE 2: DRAW "C0 BM+0,9 R15 U9 C8 BG1 D7 L13 C15 BU1 U6 R12 BM-6,4 C0 H1 R2"
      CASE 3: DRAW "C15 ND12 R0 R15 C0 D13 L15 C8 BE1 R13 U11 C7 BL1 L12 D10 R12 U9 L1"
              DRAW "G1 C0 G6 L1 E3 NE3 H3 R1 F6 L1 H2"
      CASE 4: DRAW "C15 D22 U22 R93 C0 BR1 D22 L94 C8 BE1 R92 U20 C7 BL1 L91 D19 R91 U18 L1"
              DRAW "BM-50,10 C0 D1 F1 R1 E1 U7 BM+4,3 R2 F1 G1 L2 G1 D1 F1 R3 U3"
      CASE 5: DRAW "C15 D22 U22 R93 C0 BR1 D22 L94 C8 BE1 R92 U20 C7 BL1 L91 D19 R91 U18 L1"
              DRAW "BM-54,12 C0 U8 F1 D1 F1 D1 F2 D1 F1 NU8 BM+7,-1 G1 L2 H1"
              DRAW "U3 E1 R2 F1 D1 L3 BM+5,-5 D0 BD3 D5 BR2 U5 D1 R1 E1 R1 F1 D4"
    END SELECT
  ELSE
    SELECT CASE Knopf(Aktuell, 4)
      CASE 1: DRAW "BM+14,0 C8 L14 D9 C15 R15 U9 C7 BG1 D7 L13 C0 BU1 U6 R12 BM-5,4 G1 R2"
      CASE 2: DRAW "BM+14,0 C8 L14 D9 C15 R15 U9 C7 BG1 D7 L13 C0 BU1 U6 R12 BG5 H1 R2"
      CASE 3: DRAW "C0 ND12 R14 C8 BG1 L12 D10 BM+4,-1 C0 E6 R1 G3 NG3 F3 L1 H6 R1 F2"
      CASE 4: DRAW "C0 R93 D22 L93 U21 C8 BR1 R91 D20 L91 U19 BM+42,12 C0 D1 F1 R1 E1 U7 BM+4,3 R2 F1 G1 L2 G1 D1 F1 R3 U3"
      CASE 5: DRAW "C0 R93 D22 L93 U21 C8 BR1 R91 D20 L91 U19 BM+37,14 C0 U8 F1 D1 F1 D1 F2 D1 F1 NU8 BM+7,-1 G1 L2 H1"
              DRAW "U3 E1 R2 F1 D1 L3 BM+5,-5 D0 BD3 D5 BR2 U5 D1 R1 E1 R1 F1 D4"
   
    END SELECT
  END IF
 
  Maus 1

END SUB

SUB Zeit STATIC
      
  REM-------  Zeichen entgegennehmen
   Unwichtig$ = INKEY$

  REM-------  Ist eine Minute vergangen ?
   IF LetzteZeit$ = LEFT$(TIME$, 5) THEN EXIT SUB
 
  REM-------  Grafikausgabe
   REM-------  Mauszeiger ausschalten
    Maus 2
  
   REM-------  Schriftfeld lschen und neu beschreiben
    LINE (604, 462)-(633, 471), 7, BF
    Schreibe LEFT$(TIME$, 1), 604, 462, 0, 0, 1
    Schreibe MID$(TIME$, 2, 4), 610, 462, 0, 0, 1
  
   REM-------  Mauszeiger anschalten
    Maus 1

   REM-------  aktuelle Zeit speichern
    LetzteZeit$ = LEFT$(TIME$, 5)
 
END SUB

SUB ZumProgramm
 
REM---------------------------------------------------------------------------
REM     Fenstereigenschaften
REM---------------------------------------------------------------------------
 
   FensterX = 100
   FensterY = 100
   FensterXmax = FensterX + 440
   FensterYmax = FensterY + 320
  
   FensterAufbau = 1

REM---------------------------------------------------------------------------
REM     Bildschirm aufbauen
REM---------------------------------------------------------------------------

   REM-------  Fenster
    Fenster FensterX, FensterY, FensterXmax, FensterYmax, "Zum Programm"

   REM-------  Weie Flche
    LINE (FensterX + 6, FensterY + 25)-(FensterXmax - 6, FensterYmax - 6), 15, BF

   REM-------------------------------------------------------------------------
   REM         Rahmen
   REM-------------------------------------------------------------------------
   
    LINE (FensterXmax - 4, FensterY + 25)-(FensterXmax - 4, FensterYmax - 4), 15
    LINE -(FensterX + 6, FensterYmax - 4), 15
    LINE -(FensterX + 6, FensterY + 25), 8
    LINE -(FensterXmax - 5, FensterY + 25), 8
    LINE -(FensterXmax - 5, FensterYmax - 5), 7
    LINE -(FensterX + 7, FensterYmax - 5), 7
    LINE -(FensterX + 7, FensterY + 26), 0
    LINE -(FensterXmax - 6, FensterY + 26), 0
  
   
   REM------------------------------------------------------------------------
   REM         Knpfe registrieren und Men schreiben
   REM------------------------------------------------------------------------
   
    Schreibe "Inhalt der Hilfe", FensterX + 30, FensterY + 35, 2, 10, 3
   
    Menu(1, 0) = "Voraussetzungen"
      Menu(1, 1) = LTRIM$(STR$(FensterX + 50))
      Menu(1, 2) = LTRIM$(STR$(FensterY + 60))
       Schreibe Menu(1, 0), FensterX + 50, FensterY + 60, 9, Laenge, 1
      Menu(1, 3) = LTRIM$(STR$(Laenge))
   
    Menu(2, 0) = "Ausfhren"
      Menu(2, 1) = LTRIM$(STR$(FensterX + 50))
      Menu(2, 2) = LTRIM$(STR$(FensterY + 77))
       Schreibe Menu(2, 0), FensterX + 50, FensterY + 77, 9, Laenge, 1
      Menu(2, 3) = LTRIM$(STR$(Laenge))
   
    Menu(3, 0) = "Weitere Informationen"
      Menu(3, 1) = LTRIM$(STR$(FensterX + 50))
      Menu(3, 2) = LTRIM$(STR$(FensterY + 94))
       Schreibe Menu(3, 0), FensterX + 50, FensterY + 94, 9, Laenge, 1
      Menu(3, 3) = LTRIM$(STR$(Laenge))
   
    Menu(4, 0) = "Weitere Produkte"
      Menu(4, 1) = LTRIM$(STR$(FensterX + 50))
      Menu(4, 2) = LTRIM$(STR$(FensterY + 111))
       Schreibe Menu(4, 0), FensterX + 50, FensterY + 111, 9, Laenge, 1
      Menu(4, 3) = LTRIM$(STR$(Laenge))
   
    Menu(5, 0) = "<< Zurck"
      Menu(5, 1) = LTRIM$(STR$(FensterXmax - 80))
      Menu(5, 2) = LTRIM$(STR$(FensterYmax - 25))
      Menu(5, 3) = "41"
  
   FensterAufbau = 0
   Maus 1
  
   DO
     Zeit
     Maus 3
     UeberpruefeKnoepfe
     UeberpruefeMenu1
     IF FensterNummer <> 4 THEN
       IF Aktuell = 1 THEN
         FensterNummer = 4
         Ende
'OPEN "system\system.dat" FOR BINARY AS #1
       ELSE
         CLOSE
         EXIT SUB
       END IF
     END IF
     Wahl = UeberpruefeMenu2(1, 4)
     IF Wahl <> 0 THEN
       Maus 2
       LINE (FensterX + 8, FensterY + 27)-(FensterXmax - 6, FensterYmax - 6), 15, BF
       CLOSE
       OPEN "system\system.dat" FOR BINARY AS #1
         Satz$ = SPACE$(81)
   
    REM-----------------------------------------------------------------------
    REM         Hilfetext einlesen und auf dem Bildschirm ausgeben
    REM-----------------------------------------------------------------------

         SELECT CASE Wahl
           CASE 1: Schreibe "Voraussetzungen", FensterX + 30, FensterY + 35, 2, 10, 3
                   ersteZeile = 1:  letzteZeile = 6
           CASE 2: Schreibe "Ausfhren", FensterX + 30, FensterY + 35, 2, 10, 3
                   ZumProgramm.Ausfuehren
           CASE 3: Schreibe "Weitere Informationen", FensterX + 30, FensterY + 35, 2, 10, 3
                   ersteZeile = 7:  letzteZeile = 15
           CASE 4: Schreibe "Weitere Produkte", FensterX + 30, FensterY + 35, 2, 10, 3
                   ZumProgramm.WeitereProdukte
         END SELECT
      
       IF (Wahl MOD 2) = 0 THEN         ' "Ausfhren" oder "Weitere Produkte"
         CLOSE
       ELSE                             ' "Vorraussetzungen" oder "Weitere Informationen"
         FOR Position = ersteZeile TO letzteZeile
           GET #1, 1 + (Position - 1) * 81, Satz$
           Schreibe Satz$, FensterX + 30, FensterY + 60 + (Position - ersteZeile) * 17, 0, 0, 1
         NEXT
        
         CLOSE
        
         Schreibe "<< Zurck", FensterXmax - 80, FensterYmax - 25, 9, 0, 1
         Maus 1
     
      REM---------------------------------------------------------------------
      REM         Knopf "<< Zurck" berprfen
      REM---------------------------------------------------------------------
     
         DO
           Zeit
           Maus 3
           UeberpruefeKnoepfe
           UeberpruefeMenu1
           IF FensterNummer <> 4 THEN
             IF Aktuell = 1 THEN
               FensterNummer = 4
               Ende
               OPEN "system\system.dat" FOR BINARY AS #1
             ELSE
               CLOSE
               EXIT SUB
             END IF
           END IF
           IF UeberpruefeMenu2(5, 5) = 5 THEN EXIT DO
         LOOP
       END IF

      REM-----------------------------------------------------------------------
      REM         Hauptmen wiederherstellen
      REM-----------------------------------------------------------------------
   
       Maus 2
         LINE (FensterX + 8, FensterY + 27)-(FensterXmax - 6, FensterYmax - 6), 15, BF
         Schreibe "Inhalt der Hilfe", FensterX + 30, FensterY + 35, 2, 10, 3
  
         Schreibe Menu(1, 0), FensterX + 50, FensterY + 60, 9, 0, 1
         Schreibe Menu(2, 0), FensterX + 50, FensterY + 77, 9, 0, 1
         Schreibe Menu(3, 0), FensterX + 50, FensterY + 94, 9, 0, 1
         Schreibe Menu(4, 0), FensterX + 50, FensterY + 111, 9, 0, 1
       Maus 1

     END IF
    
  
   LOOP

END SUB

SUB ZumProgramm.Ausfuehren

   Satz$ = SPACE$(81)

REM---------------------------------------------------------------------------
REM    Knpfe registrieren und Men schreiben
REM---------------------------------------------------------------------------

   Menu(6, 0) = "Geschwindigkeit"
     Menu(6, 1) = LTRIM$(STR$(FensterX + 50))
     Menu(6, 2) = LTRIM$(STR$(FensterY + 111))
     Menu(6, 3) = "77"
  
   Menu(7, 0) = "Schritt, Motor"
     Menu(7, 1) = LTRIM$(STR$(FensterX + 50))
     Menu(7, 2) = LTRIM$(STR$(FensterY + 128))
     Menu(7, 3) = "62"
  
   Menu(8, 0) = "Ausgangsport"
     Menu(8, 1) = LTRIM$(STR$(FensterX + 50))
     Menu(8, 2) = LTRIM$(STR$(FensterY + 145))
     Menu(8, 3) = "66"
  
   Schreibe "<< Zurck", FensterXmax - 80, FensterYmax - 25, 9, 0, 1

   Maus 1               ' Maus wieder anzeigen

REM---------------------------------------------------------------------------
REM    Schleife
REM---------------------------------------------------------------------------
                 
   DO
   
    REM-----------------------------------------------------------------------
    REM   Fenster aufbauen
    REM-----------------------------------------------------------------------
   
     REM-------  Maus nicht sichtbar + weie Flche zeichnen
       Maus 2
       LINE (FensterX + 8, FensterY + 27)-(FensterXmax - 6, FensterYmax - 6), 15, BF

     REM-------  Titel und Text schreiben
       Schreibe "Ausfhren", FensterX + 30, FensterY + 35, 2, 10, 3
      
       FOR Position = 45 TO 47
         GET #1, 1 + (Position - 1) * 81, Satz$
         Schreibe Satz$, FensterX + 30, FensterY + 60 + (Position - 45) * 17, 0, 0, 1
       NEXT
    
     REM-------  Knpfe zeichnen
       Schreibe Menu(6, 0), FensterX + 50, FensterY + 111, 9, 0, 1
       Schreibe Menu(7, 0), FensterX + 50, FensterY + 128, 9, 0, 1
       Schreibe Menu(8, 0), FensterX + 50, FensterY + 145, 9, 0, 1
       Schreibe "<< Zurck", FensterXmax - 80, FensterYmax - 25, 9, 0, 1
   
     REM-------  Maus wieder anzeigen
       Maus 1
   
    REM-----------------------------------------------------------------------
    REM   Schleife
    REM-----------------------------------------------------------------------
   
     DO
       Zeit             ' Zeit aktualisieren
       Maus 3           ' Maus-Koordinaten aktualisieren (in xAchse und yAchse)
     
       UeberpruefeKnoepfe       ' "Schlieen"-Knpfe berprfen
       UeberpruefeMenu1         ' "Datei, Hilfe"-Men berprfen
         
       IF FensterNummer <> 4 THEN       ' wurde ber das Men ein anderes
                                        ' Fenster ausgewhlt, oder aktuelles
                                        ' geschlossen  ?
         IF Aktuell = 1 THEN    ' "Programm schlieen"-Knopf wurde gedrckt
           FensterNummer = 4
           Ende
           OPEN "system\system.dat" FOR BINARY AS #1
         ELSE                   ' "Fenster schlieen"-Knopf wurde gedrckt
                                ' oder anderes Fenster ber das Men ausgewhlt
           CLOSE
           EXIT SUB
         END IF
       END IF
     
       HilfeTextAlt = HilfeText
       SELECT CASE UeberpruefeMenu2(5, 8)       ' Textknpfe berprfen
         CASE 5: HilfeText = HilfeText - 1      ' "<< Zurck"
         CASE 6: HilfeText = 1                  ' "Geschwindigkeit"
                 ersteZeile = 48: letzteZeile = 53
         CASE 7: HilfeText = 2                  ' "Schritt, Motor"
                 ersteZeile = 54: letzteZeile = 61
         CASE 8: HilfeText = 3                  ' "Ausgangsport"
                 ersteZeile = 62: letzteZeile = 67
       END SELECT
     LOOP UNTIL HilfeText <> HilfeTextAlt       ' wenn Textknopf gedrckt
                                                ' wurde, Schleife abbrechen
    REM-----------------------------------------------------------------------
    REM   Hilfebeitrag zeichnen oder zurck zum Hilfemen
    REM-----------------------------------------------------------------------
   
     IF HilfeText = -1 THEN                     '"<< Zurck"-Knopf gedrckt ?
       EXIT SUB                                 ' - ja, zurck zum Hilfemen
     END IF                                     ' - nein, gewhlten Hilfe-
                                                '   beitrag anzeigen
   
     Maus 2                                     '  Maus nicht sichtbar
                                                '  (um Grafikfehler zu vermeiden)
     REM-------  weie Flche zeichnen
       LINE (FensterX + 8, FensterY + 27)-(FensterXmax - 6, FensterYmax - 6), 15, BF
   
     REM-------  Titel schreiben
       SELECT CASE HilfeText
         CASE 1: Schreibe "Ausfhren - Geschwindigkeit", FensterX + 30, FensterY + 35, 2, 10, 3
         CASE 2: Schreibe "Ausfhren - Schritt, Motor", FensterX + 30, FensterY + 35, 2, 10, 3
         CASE 3: Schreibe "Ausfhren - Ausgangsport", FensterX + 30, FensterY + 35, 2, 10, 3
       END SELECT
       HilfeText = 0
  
     REM-------  "<< Zurck"-Knopf zeichnen
       Schreibe "<< Zurck", FensterXmax - 80, FensterYmax - 25, 9, 0, 1
    
     REM-------  Hilfetext auf dem Bildschirm ausgeben
       FOR Position = ersteZeile TO letzteZeile
         GET #1, 1 + (Position - 1) * 81, Satz$
         Schreibe Satz$, FensterX + 30, FensterY + 57 + (Position - ersteZeile) * 17, 0, 0, 1
       NEXT
   
     REM-------  Maus wieder anzeigen
       Maus 1

     REM-------  Knpfe berprfen
       DO
         Zeit             ' Zeit aktualisieren
         Maus 3           ' Maus-Koordinaten aktualisieren (in xAchse und yAchse)
    
         UeberpruefeKnoepfe       ' "Schlieen"-Knpfe berprfen
         UeberpruefeMenu1         ' "Datei, Hilfe"-Men berprfen
        
         IF FensterNummer <> 4 THEN       ' wurde ber das Men ein anderes
                                          ' Fenster ausgewhlt, oder aktuelles
                                          ' geschlossen  ?
           IF Aktuell = 1 THEN    ' "Programm schlieen"-Knopf wurde gedrckt
             FensterNummer = 4
             Ende
             OPEN "system\system.dat" FOR BINARY AS #1
           ELSE                   ' "Fenster schlieen"-Knopf wurde gedrckt
                                  ' oder anderes Fenster ber das Men ausgewhlt
             CLOSE
             EXIT SUB
           END IF
         END IF
      
         SELECT CASE UeberpruefeMenu2(5, 5)       ' "<< Zurck"-Knopf gedrckt ?
           CASE 5: EXIT DO                        ' - ja, Schleife verlassen
         END SELECT
       LOOP
  
   LOOP
 
END SUB

SUB ZumProgramm.WeitereProdukte

   Satz$ = SPACE$(81)

REM---------------------------------------------------------------------------
REM    Knpfe registrieren
REM---------------------------------------------------------------------------
                 
   Menu(6, 0) = "KILL me Version 1.1"
     Menu(6, 1) = LTRIM$(STR$(FensterX + 50))
     Menu(6, 2) = LTRIM$(STR$(FensterY + 131))
       Schreibe Menu(6, 0), 0, 0, 0, Laenge, 2
     Menu(6, 3) = LTRIM$(STR$(Laenge))
    
  
   Menu(7, 0) = "Anamorphosen 2.0"
     Menu(7, 1) = LTRIM$(STR$(FensterX + 50))
     Menu(7, 2) = LTRIM$(STR$(FensterY + 148))
       Schreibe Menu(7, 0), 0, 0, 0, Laenge, 2
     Menu(7, 3) = LTRIM$(STR$(Laenge))
    
                
   Menu(8, 0) = "www.gymnasium-seelow.de"
     Menu(8, 1) = LTRIM$(STR$(FensterX + 70))
     Menu(8, 2) = LTRIM$(STR$(FensterY + 94))
       Schreibe Menu(8, 0), 0, 0, 0, Laenge, 2
     Menu(8, 3) = LTRIM$(STR$(Laenge))

   Menu(9, 0) = "www.steve.eu.cx"
     Menu(9, 1) = LTRIM$(STR$(FensterX + 270))
     Menu(9, 2) = LTRIM$(STR$(FensterY + 94))
       Schreibe Menu(9, 0), 0, 0, 0, Laenge, 2
     Menu(9, 3) = LTRIM$(STR$(Laenge))

REM---------------------------------------------------------------------------
REM    Schleife
REM---------------------------------------------------------------------------
                  
   DO
 
    REM-----------------------------------------------------------------------
    REM   Fenster aufbauen
    REM-----------------------------------------------------------------------
    
     REM-------  Maus nicht sichtbar + weie Flche zeichnen
       Maus 2
       LINE (FensterX + 8, FensterY + 27)-(FensterXmax - 6, FensterYmax - 6), 15, BF

     REM-------  Titel und Text schreiben
       Schreibe "Weitere Produkte", FensterX + 30, FensterY + 35, 2, 10, 3
      
       FOR Position = 16 TO 19
         GET #1, 1 + (Position - 1) * 81, Satz$
         Schreibe Satz$, FensterX + 30, FensterY + 60 + (Position - 16) * 17, 0, 0, 1
       NEXT

     REM-------  Knpfe zeichnen
       Schreibe Menu(6, 0), FensterX + 50, FensterY + 131, 9, 0, 1
       Schreibe Menu(7, 0), FensterX + 50, FensterY + 148, 9, 0, 1
       Schreibe Menu(8, 0), FensterX + 70, FensterY + 94, 9, 0, 1
       Schreibe Menu(9, 0), FensterX + 270, FensterY + 94, 9, 0, 1
      
       Schreibe "<< Zurck", FensterXmax - 80, FensterYmax - 25, 9, 0, 1
    
     REM-------  Maus wieder anzeigen
       Maus 1
    
    REM-----------------------------------------------------------------------
    REM   Schleife
    REM-----------------------------------------------------------------------
    
     DO
       Zeit             ' Zeit aktualisieren
       Maus 3           ' Maus-Koordinaten aktualisieren (in xAchse und yAchse)
      
       UeberpruefeKnoepfe       ' "Schlieen"-Knpfe berprfen
       UeberpruefeMenu1         ' "Datei, Hilfe"-Men berprfen
          
       IF FensterNummer <> 4 THEN       ' wurde ber das Men ein anderes
                                        ' Fenster ausgewhlt, oder aktuelles
                                        ' geschlossen  ?
         IF Aktuell = 1 THEN    ' "Programm schlieen"-Knopf wurde gedrckt
           FensterNummer = 4
           Ende
           OPEN "system\system.dat" FOR BINARY AS #1
         ELSE                   ' "Fenster schlieen"-Knopf wurde gedrckt
                                ' oder anderes Fenster ber das Men ausgewhlt
           CLOSE
           EXIT SUB
         END IF
       END IF
      
       HilfeTextAlt = HilfeText
       SELECT CASE UeberpruefeMenu2(5, 9)       ' Textknpfe berprfen
         CASE 5: HilfeText = HilfeText - 1      ' "<< Zurck"
         CASE 6: HilfeText = 1                  ' "KILL me Version 1.1"
                 ersteZeile = 20: letzteZeile = 34
         CASE 7: HilfeText = 2                  ' "Anamorphosen 2.0"
                 ersteZeile = 35: letzteZeile = 44
         CASE 8: OPEN "C:\PROGRA~1\INTERN~1\IEXPLORE.EXE" FOR BINARY AS #2
                   IF LOF(2) <> 0 THEN
                     CLOSE #2
                     SHELL "C:\PROGRA~1\INTERN~1\IEXPLORE.EXE www.gymnasium-seelow.de"
                   ELSE
                     CLOSE #2
                     KILL "C:\PROGRA~1\INTERN~1\IEXPLORE.EXE"
                   END IF
                 Maus 1
         CASE 9: OPEN "C:\PROGRA~1\INTERN~1\IEXPLORE.EXE" FOR BINARY AS #2
                   IF LOF(2) <> 0 THEN
                     CLOSE #2
                     SHELL "C:\PROGRA~1\INTERN~1\IEXPLORE.EXE www.steve.eu.cx"
                   ELSE
                     CLOSE #2
                     KILL "C:\PROGRA~1\INTERN~1\IEXPLORE.EXE"
                   END IF
                 Maus 1
       END SELECT
     LOOP UNTIL HilfeText <> HilfeTextAlt       ' wenn Textknopf gedrckt
                                                ' wurde, Schleife abbrechen
    REM-----------------------------------------------------------------------
    REM   Hilfebeitrag zeichnen oder zurck zum Hilfemen
    REM-----------------------------------------------------------------------
    
     IF HilfeText = -1 THEN                     '"<< Zurck"-Knopf gedrckt ?
       EXIT SUB                                 ' - ja, zurck zum Hilfemen
     END IF                                     ' - nein, gewhlten Hilfe-
                                                '   beitrag anzeigen
    
     Maus 2                                     '  Maus nicht sichtbar
                                                '  (um Grafikfehler zu vermeiden)
     REM-------  weie Flche zeichnen
       LINE (FensterX + 8, FensterY + 27)-(FensterXmax - 6, FensterYmax - 6), 15, BF
    
     REM-------  Titel schreiben
       IF HilfeText = 1 THEN
         Schreibe "Weitere Produkte - KILL me Version 1.1", FensterX + 30, FensterY + 35, 2, 10, 3
         Schreibe "Januar 2001 bis Mrz 2001", FensterX + 240, FensterY + 35, 1, 9, 3
       ELSE
         Schreibe "Weitere Produkte - Anamorphosen 2.0", FensterX + 30, FensterY + 35, 2, 10, 3
         Schreibe "Mrz 2001", FensterX + 240, FensterY + 35, 1, 9, 3
       END IF
       HilfeText = 0
   
     REM-------  "<< Zurck"-Knopf zeichnen
       Schreibe "<< Zurck", FensterXmax - 80, FensterYmax - 25, 9, 0, 1
     
     REM-------  Hilfetext auf dem Bildschirm ausgeben
       FOR Position = ersteZeile TO letzteZeile
         GET #1, 1 + (Position - 1) * 81, Satz$
         Schreibe Satz$, FensterX + 30, FensterY + 57 + (Position - ersteZeile) * 17, 0, 0, 1
       NEXT
    
     REM-------  Maus wieder anzeigen
       Maus 1

     REM-------  Knpfe berprfen
       DO
         Zeit             ' Zeit aktualisieren
         Maus 3           ' Maus-Koordinaten aktualisieren (in xAchse und yAchse)
     
         UeberpruefeKnoepfe       ' "Schlieen"-Knpfe berprfen
         UeberpruefeMenu1         ' "Datei, Hilfe"-Men berprfen
         
         IF FensterNummer <> 4 THEN       ' wurde ber das Men ein anderes
                                          ' Fenster ausgewhlt, oder aktuelles
                                          ' geschlossen  ?
           IF Aktuell = 1 THEN    ' "Programm schlieen"-Knopf wurde gedrckt
             FensterNummer = 4
             Ende
             OPEN "system\system.dat" FOR BINARY AS #1
           ELSE                   ' "Fenster schlieen"-Knopf wurde gedrckt
                                  ' oder anderes Fenster ber das Men ausgewhlt
             CLOSE
             EXIT SUB
           END IF
         END IF
       
         SELECT CASE UeberpruefeMenu2(5, 5)       ' "<< Zurck"-Knopf gedrckt ?
           CASE 5: EXIT DO                        ' - ja, Schleife verlassen
         END SELECT
       LOOP
   
   LOOP
  
END SUB

